/*
 *  Copyright 1995 Science Applications International Corporation.
 */

/*
 * NAME
 *
 * 
 * FILE 
 *     @(#)align_IE.c	6.1
 *
 * SYNOPSIS
 *
 *
 * DESCRIPTION
 *	functions to align keys with responses, and keys with keys
 *
 * DIAGNOSTICS
 *
 *
 * FILES
 *
 *
 * NOTES
 * 
 * SEE ALSO
 *
 * AUTHOR
 *	Gary Dungca	August 1995
 */

#ifdef SCCSID
static char SccsId[] = "@(#)align_IE.c	6.1\t09/08/97\tSAIC";
#endif

#undef SCCSID
#include  "muc_defs.h"
#include  "muc.h"
#include  "muc_protos.h"
#include  "muc_globals.h"


/*  internal function declarations */

static void align__in_ccl(TABLE *key_insts, 
			  TABLE *response_insts,
			  TABLE *inst_pairs);
static void align_cin(TABLE *key_insts,
		      TABLE *response_insts,
		      TABLE *inst_pairs );
static void align_cin_pair_all(TABLE *key_insts,
			       TABLE *response_insts,
			       Inst_pair **all_pairs );
static void align__sl_cin(TABLE *key_slots,
			  TABLE *response_slots,
			  TABLE *slot_pairs );
static void align_csl(TABLE *key_slots,
		      TABLE *response_slots,
		      TABLE *slot_pairs );
static Slot_pair *pair_csl(Slot *key_slot,
			   Slot *response_slot );
static void align__mf_csl(TABLE *key_mfils,
			  TABLE *response_mfils,
			  TABLE *mfil_pairs );
static void align_cmf(TABLE *key_mfils,
		      TABLE *response_mfils,
		      TABLE *mfil_pairs );
static void align_cmf_pair_all(TABLE *key_mfils,
			       TABLE *response_mfils,
			       Mfil_pair **all_pairs );
static void align_cmf_choose_pairs(Mfil_pair **all_pairs, 
				   int num_all_pairs, 
				   TABLE *mfil_pairs );
static Mfil_pair *pair_cmf(Mfil *key_mfil,
			   Mfil *response_mfil );
static void align__sf_cmf(TABLE *key_sfils,
			  TABLE *response_sfils,
			  TABLE *sfil_pairs );
static void align_csf(TABLE *key_sfils,
		      TABLE *response_sfils,
		      TABLE *sfil_pairs );
static void align_csf_pair_all(TABLE *key_sfils,
			       TABLE *response_sfils,
			       Sfil_pair **all_pairs );
static void align_csf_choose_pairs(Sfil_pair **all_pairs, 
				   int num_all_pairs, 
				   TABLE *sfil_pairs );
static Sfil_pair *pair_csf(Sfil *key_sfil,
			   Sfil *response_sfil );
static void align_iin(TABLE *key_insts,
		      TABLE *response_insts,
		      TABLE *inst_pairs );
static void align_iin_pair_all(TABLE *key_insts,
			       TABLE *response_insts,
			       Inst_pair **all_pairs );
static void align_iin_choose_pairs(Inst_pair **all_pairs, 
				   int num_all_pairs, 
				   TABLE *inst_pairs );
static Inst_pair *pair_iin(Inst *key_inst,
			   Inst *response_inst );
static void align__sl_iin(TABLE *key_slots,
			  TABLE *response_slots,
			  TABLE *slot_pairs );
static void align_isl(TABLE *key_slots,
		      TABLE *response_slots,
		      TABLE *slot_pairs );
static Slot_pair *pair_isl(Slot *key_slot,
			   Slot *response_slot );
static void align__mf_isl(TABLE *key_mfils,
			  TABLE *response_mfils,
			  TABLE *mfil_pairs );
static void align_imf(TABLE *key_mfils,
		      TABLE *response_mfils,
		      TABLE *mfil_pairs );
static void align_imf_pair_all(TABLE *key_mfils,
			       TABLE *response_mfils,
			       Mfil_pair **all_pairs );
static void align_imf_choose_pairs(Mfil_pair **all_pairs, 
				   int num_all_pairs, 
				   TABLE *mfil_pairs );
static Mfil_pair *pair_imf(Mfil *key_mfil,
			   Mfil *response_mfil );
static void align__sf_imf(TABLE *key_sfils,
			  TABLE *response_sfils,
			  TABLE *sfil_pairs );
static void align_isf(TABLE *key_sfils,
		      TABLE *response_sfils,
		      TABLE *sfil_pairs );
static Sfil_pair *pair_isf(Sfil *key_sfil,
			   Sfil *response_sfil );
static void align_usl(TABLE *key_slots, 
		      TABLE *response_slots, 
		      TABLE *slot_pairs );
static Slot_pair *pair_usl(Slot *key_slot,
			   Slot *response_slot);
static void align__mf_usl(TABLE *key_mfils,
			  TABLE *response_mfils,
			  TABLE *mfil_pairs );
static void align_umf(TABLE *key_mfils, 
		      TABLE *response_mfils,
		      TABLE *mfil_pairs );
static Mfil_pair *pair_umf(Mfil *key_mfil,
			   Mfil *response_mfil);
static void align__sf_umf(TABLE *key_sfils, 
			  TABLE *response_sfils,
			  TABLE *sfil_pairs );
static void align_usf(TABLE *key_sfils, 
		      TABLE *response_sfils,
		      TABLE *sfil_pairs );
static Sfil_pair *pair_usf(Sfil *key_sfil,	
			   Sfil *response_sfil);
static void align_rsl(TABLE *key_slots, TABLE *slot_pairs );
static Slot_pair *pair_rsl(Slot *key_slot );
static void align__mf_rsl(TABLE *mfils, TABLE *mfil_pairs );
static void align_rmf(TABLE *key_mfils, TABLE *mfil_pairs );
static Mfil_pair *pair_rmf(Mfil *key_mfil );
static void align__sf_rmf(TABLE *sfils, TABLE *sfil_pairs );
static void align_rsf(TABLE *key_sfils, TABLE *sfil_pairs );
static Sfil_pair *pair_rsf(Sfil *key_sfil );
static void align__sl_min(TABLE *key_slots, TABLE *slot_pairs );
static void align_msl(TABLE *key_slots, TABLE *slot_pairs );
static Slot_pair *pair_msl(Slot *key_slot );
static void align__mf_msl(TABLE *key_mfils, TABLE *mfil_pairs );
static void align_mmf_k2r(TABLE *key_mfils, TABLE *mfil_pairs );
static void align_mmf_k2k(TABLE *key_mfils, TABLE *mfil_pairs );
static Mfil_pair *pair_mmf(Mfil *key_mfil );
static void align__sf_mmf(TABLE *key_sfils, TABLE *sfil_pairs );
static void align_msf(TABLE *key_sfils, TABLE *sfil_pairs );
static Sfil_pair *pair_msf(Sfil *sfil );
static void align__sl_sin(TABLE *slots, TABLE *slot_pairs );
static void align_ssl(TABLE *slots, TABLE *slot_pairs );
static Slot_pair *pair_ssl(Slot *slot );
static void align__mf_ssl(TABLE *mfils, TABLE *mfil_pairs );
static void align_smf(TABLE *mfils, TABLE *mfil_pairs );
static Mfil_pair *pair_smf(Mfil *mfil );
static void align__sf_smf(TABLE *sfils, TABLE *sfil_pairs );
static void align_ssf(TABLE *sfils, TABLE *sfil_pairs );
static Sfil_pair *pair_ssf(Sfil *sfil );
static void align__sl_oin(TABLE *slots, TABLE *slot_pairs );
static void align_osl_oin(TABLE *slots, TABLE *slot_pairs );
static void align_osl(TABLE *slots, TABLE *slot_pairs );
static Slot_pair *pair_osl(Slot *slot );
static void align__mf_osl(TABLE *mfils, TABLE *mfil_pairs );
static void align_omf(TABLE *mfils, TABLE *mfil_pairs );
static Mfil_pair *pair_omf(Mfil *mfil );
static void align__sf_omf(TABLE *sfils, TABLE *sfil_pairs );
static void align_osf(TABLE *sfils, TABLE *sfil_pairs );
static Sfil_pair *pair_osf(Sfil *sfil );

/************************************************************************
 *									*
 *  align_IE
 *									*
 *     In the order of the class names in the "map order" option, 
 *     align the key and response classes in the catalog entry
 *
 ***********************************************************************/

void
align_IE(Catalog_entry *entry)
{
	TABLE  *map_order;
	char   *mapname;
	char   *classname;
	Class_def *class_def;
	Clas   *key_clas, *response_clas;
	Clas_pair *clas_pair;

	map_order = option_find_values(MUC_Options, ":map_order");

	/* map the classes for which there are key and response instances */
  
	table_first( map_order );
	for(mapname=(char *)table_next(map_order);
	    mapname;
	    mapname=(char *)table_next(map_order))
	{
		class_def = class_def_find(MUC_Class_defs, mapname);
		if(class_def)
			classname = class_def->name;
		else
		{
			fprintf(stderr,
				"[align_IE]: \'%s\' not found in class defs\n",
				mapname);
			exit(1);
		}

		key_clas = clas_find( entry->key_classes, classname );
		response_clas = clas_find( entry->response_classes, classname );
		clas_pair = clas_pair_find( entry->clas_pairs, classname );

		key_clas->is_aligned = True;
		response_clas->is_aligned = True;
		align__in_ccl(key_clas->insts, 
			      response_clas->insts,
			      clas_pair->inst_pairs);
		inst_pair_sum_tallies(clas_pair->tallies,
				      clas_pair->inst_pairs);
		clas_pair->score = 
			compute_tallies_f(clas_pair->tallies,
					  F_PR);
	}
	clas_pair_sum_tallies(entry->total_slot_tallies, 
			      entry->clas_pairs);
	entry->total_slot_score = 
		compute_tallies_f( entry->total_slot_tallies, F_PR );
  
	return;
}

static
void
align__in_ccl( TABLE *key_insts, TABLE *response_insts, TABLE *inst_pairs )
{
	inst_clear_aligned_flags( key_insts );
	inst_clear_aligned_flags( response_insts );

	align_cin( key_insts, response_insts, inst_pairs );

	if( IS_K2R )
		align_oin( key_insts, inst_pairs );      

	if( IS_K2R )
		align_iin( key_insts, response_insts, inst_pairs );

	align_min( key_insts, inst_pairs );
	align_sin( response_insts, inst_pairs );
}


/*******************************************  
 *
 * alignment of "correct" instances
 *
 *******************************************
 */

static
void
align_cin( TABLE *key_insts, TABLE *response_insts, TABLE *inst_pairs )
{
	int num_unaligned_keys, num_unaligned_responses, num_all_pairs;
	Inst_pair **all_pairs;
  
	num_unaligned_keys      = inst_count_unaligned( key_insts );
	num_unaligned_responses = inst_count_unaligned( response_insts );
	num_all_pairs = num_unaligned_keys * num_unaligned_responses;
  
	all_pairs = (Inst_pair **)calloc(num_all_pairs, sizeof(Inst_pair *));

	align_cin_pair_all(key_insts, response_insts, all_pairs);

	qsort(all_pairs, 
	      num_all_pairs, 
	      sizeof(Inst_pair *), 
	      inst_pair_f_compare );

	align_cin_choose_pairs(all_pairs, 
			       num_all_pairs, 
			       inst_pairs);

	free(all_pairs);
}

static
void
align_cin_pair_all(TABLE *key_insts, 
		   TABLE *response_insts, 
		   Inst_pair **all_pairs )
{
	int i=0;
	Inst *key_inst, *response_inst;

	table_first(key_insts);
	for(key_inst = (Inst *)table_next(key_insts);
	    key_inst;
	    key_inst = (Inst *)table_next(key_insts) )
		if( !(key_inst->is_aligned) )
		{
			table_first(response_insts);
			for(response_inst = (Inst *)table_next(response_insts);
			    response_inst;
			    response_inst = (Inst *)table_next(response_insts))
				if( !(response_inst->is_aligned) )
					all_pairs[i++] = pair_cin(key_inst,
								  response_inst );
		}
}

void
align_cin_choose_pairs(Inst_pair **all_pairs, 
		       int num_all_pairs, 
		       TABLE *inst_pairs )
{
	int i;
	Inst_pair *inst_pair;
	for(i=0; i<num_all_pairs; i++)
	{
		inst_pair = all_pairs[i];
		if(((!(inst_pair->key_inst->is_aligned))
		    &&
		    (!(inst_pair->response_inst->is_aligned))) 

		   &&

		   (inst_pair->weighted_score 
		    > 
		    inst_pair->key_inst->its_class_def->map_threshold ))
		{
			table_append((char *) inst_pair, inst_pairs );

			inst_pair->key_inst->is_aligned = True;
			inst_pair->key_inst->its_pair = inst_pair;
			inst_pair->key_inst->aligned_with = 
				inst_pair->response_inst;
			

			inst_pair->response_inst->is_aligned = True;
			inst_pair->response_inst->its_pair = inst_pair;
			inst_pair->response_inst->aligned_with =
				inst_pair->key_inst;
		}
		else
			inst_pair_release( (char *)inst_pair );
    }
}
	  
Inst_pair *
pair_cin( Inst *key_inst, Inst *response_inst )
{
	Inst_pair *inst_pair;
	inst_pair = inst_pair_create( key_inst, response_inst, COR );
	align__sl_cin(key_inst->slots, 
		      response_inst->slots, 
		      inst_pair->slot_pairs );
	slot_pair_sum_tallies(inst_pair->tallies, inst_pair->slot_pairs );
	inst_pair->score = compute_tallies_f( inst_pair->tallies, F_PR );
	inst_pair->weighted_score = 
		slot_pair_sum_weighted_scores( inst_pair->slot_pairs );
	return inst_pair;
}

static
void
align__sl_cin( TABLE *key_slots, TABLE *response_slots, TABLE *slot_pairs )
{
	slot_clear_aligned_flags( key_slots );
	slot_clear_aligned_flags( response_slots );

	if( IS_K2R )
		align_rsl( key_slots, slot_pairs );

	align_usl( key_slots, response_slots, slot_pairs );

	align_csl( key_slots, response_slots, slot_pairs );

	if( IS_K2R )
		align_osl( key_slots, slot_pairs );

	align_msl( key_slots, slot_pairs );
	align_ssl( response_slots, slot_pairs );  
}

static
void
align_csl( TABLE *key_slots, TABLE *response_slots, TABLE *slot_pairs )
{
	Slot *key_slot, *response_slot;
	Slot_pair *slot_pair;
  
	table_first( key_slots );
	for(key_slot=(Slot *)table_next(key_slots);
	    key_slot;
	    key_slot=(Slot *)table_next(key_slots))
		if( !(key_slot->is_aligned) )
		{
			response_slot=slot_find(response_slots, key_slot->name);
			if(response_slot)
			{
				slot_pair = pair_csl( key_slot, response_slot );
				key_slot->is_aligned = True;
				response_slot->is_aligned = True;
				table_append((char *) slot_pair, slot_pairs );
			}
		}	
}	

static
Slot_pair *
pair_csl( Slot *key_slot, Slot *response_slot )
{
	Slot_pair *slot_pair;
	
	slot_pair = slot_pair_create( key_slot, response_slot, COR );
	align__mf_csl( key_slot->mfils, response_slot->mfils, slot_pair->mfil_pairs );
	mfil_pair_sum_tallies( slot_pair->tallies, slot_pair->mfil_pairs );
	slot_pair->score = compute_tallies_f(slot_pair->tallies, F_PR );
	return slot_pair;
}

static
void
align__mf_csl(TABLE *key_mfils, TABLE *response_mfils, TABLE *mfil_pairs )
{
	mfil_clear_aligned_flags( key_mfils );
	mfil_clear_aligned_flags( response_mfils );  
	
	if( IS_K2R )
		align_rmf(key_mfils, mfil_pairs);
	
	align_cmf( key_mfils, response_mfils, mfil_pairs );
	
	if( IS_K2R )
	{
		align_smf( response_mfils, mfil_pairs );
		align_umf( key_mfils, response_mfils, mfil_pairs );
	}
	else
	{
		align_mmf_k2k( key_mfils, mfil_pairs );
		align_smf( response_mfils, mfil_pairs );
	}
}

static
void
align_cmf( TABLE *key_mfils, TABLE *response_mfils, TABLE *mfil_pairs )
{
	int num_unaligned_keys, num_unaligned_responses, num_all_pairs;
	Mfil_pair **all_pairs;
	
	num_unaligned_keys      = mfil_count_unaligned( key_mfils );
	num_unaligned_responses = mfil_count_unaligned( response_mfils );
	num_all_pairs = num_unaligned_keys * num_unaligned_responses;
	
	all_pairs = (Mfil_pair **)calloc(num_all_pairs, sizeof(Mfil_pair *));
	
	align_cmf_pair_all(key_mfils, response_mfils, all_pairs);
	
	qsort( all_pairs, num_all_pairs, sizeof(Mfil_pair *), mfil_pair_f_compare );
	
	align_cmf_choose_pairs(all_pairs, num_all_pairs, mfil_pairs );
	
	free(all_pairs);
}

static
void
align_cmf_pair_all(TABLE *key_mfils, TABLE *response_mfils, Mfil_pair **all_pairs )
{
	int i=0;
	Mfil *key_mfil, *response_mfil;
	
	table_first(key_mfils);
	for(key_mfil = (Mfil *)table_next(key_mfils);
	    key_mfil;
	    key_mfil = (Mfil *)table_next(key_mfils) )
		if( !(key_mfil->is_aligned) )
		{
			table_first(response_mfils);
			for(response_mfil = (Mfil *)table_next(response_mfils);
			    response_mfil;
			    response_mfil = (Mfil *)table_next(response_mfils) )
				if( !(response_mfil->is_aligned) )
					all_pairs[i++] = pair_cmf( key_mfil, response_mfil );
		}
}

static
void
align_cmf_choose_pairs(Mfil_pair **all_pairs, 
		       int num_all_pairs, 
		       TABLE *mfil_pairs )
{
	int i;
	Mfil_pair *mfil_pair;
	
	for(i=0; i<num_all_pairs; i++)
	{
		mfil_pair = all_pairs[i];
		if((!(mfil_pair->key_mfil->is_aligned))
		    &&
		    (!(mfil_pair->response_mfil->is_aligned)))
		{
			table_append((char *) mfil_pair, mfil_pairs );
			mfil_pair->key_mfil->is_aligned = True;
			mfil_pair->response_mfil->is_aligned = True;
		}
		else
			mfil_pair_release( (char *)mfil_pair );
	}
}

static
Mfil_pair *
pair_cmf( Mfil *key_mfil, Mfil *response_mfil )
{
	Mfil_pair *mfil_pair;
	mfil_pair = mfil_pair_create( key_mfil, response_mfil, COR );
	align__sf_cmf( key_mfil->sfils, response_mfil->sfils, mfil_pair->sfil_pairs );
	sfil_pair_sum_tallies( mfil_pair->tallies, mfil_pair->sfil_pairs );
	mfil_pair->score = compute_tallies_f( mfil_pair->tallies , F_PR );
	return mfil_pair;
}


static
void
align__sf_cmf(TABLE *key_sfils, TABLE *response_sfils, TABLE *sfil_pairs )
{
	sfil_clear_aligned_flags( key_sfils );
	sfil_clear_aligned_flags( response_sfils );  
	
	if( IS_K2R )
		align_rsf(key_sfils, sfil_pairs);
	
	align_csf( key_sfils, response_sfils, sfil_pairs );
	
	align_msf( key_sfils, sfil_pairs );
	align_ssf( response_sfils, sfil_pairs );
}

static
void
align_csf( TABLE *key_sfils, TABLE *response_sfils, TABLE *sfil_pairs )
{
	int num_unaligned_keys, num_unaligned_responses, num_all_pairs;
	Sfil_pair **all_pairs;
	
	num_unaligned_keys      = sfil_count_unaligned( key_sfils );
	num_unaligned_responses = sfil_count_unaligned( response_sfils );
	num_all_pairs = num_unaligned_keys * num_unaligned_responses;
	
	all_pairs = (Sfil_pair **)calloc(num_all_pairs, sizeof(Sfil_pair *));
	
	align_csf_pair_all(key_sfils,
			   response_sfils,
			   all_pairs);
	
	qsort(all_pairs, 
	      num_all_pairs, 
	      sizeof(Sfil_pair *), 
	      sfil_pair_f_compare );
	
	align_csf_choose_pairs(all_pairs,
			       num_all_pairs,
			       sfil_pairs );
	
	free(all_pairs);
}

static
void
align_csf_pair_all(TABLE *key_sfils, TABLE *response_sfils, Sfil_pair **all_pairs )
{
	int i=0;
	Sfil *key_sfil, *response_sfil;
	
	table_first(key_sfils);
	for(key_sfil = (Sfil *)table_next(key_sfils);
	    key_sfil;
	    key_sfil = (Sfil *)table_next(key_sfils) )
		if( !(key_sfil->is_aligned) )
		{
			table_first(response_sfils);
			for(response_sfil = (Sfil *)table_next(response_sfils);
			    response_sfil;
			    response_sfil = (Sfil *)table_next(response_sfils) )
				if( !(response_sfil->is_aligned) )
					all_pairs[i++] = pair_csf( key_sfil, response_sfil );
		}
}

static
void
align_csf_choose_pairs(Sfil_pair **all_pairs, 
		       int num_all_pairs, 
		       TABLE *sfil_pairs )
{
	int i;
	Sfil_pair *sfil_pair;
	
	for(i=0; i<num_all_pairs; i++)
	{
		sfil_pair = all_pairs[i];
		if((!(sfil_pair->key_sfil->is_aligned))
		    &&
		    (!(sfil_pair->response_sfil->is_aligned)))
		{
			table_append((char *) sfil_pair, sfil_pairs );
			sfil_pair->key_sfil->is_aligned = True;
			sfil_pair->response_sfil->is_aligned = True;
		}
		else
			sfil_pair_release( (char *)sfil_pair );
	}
}

static
Sfil_pair *
pair_csf( Sfil *key_sfil, Sfil *response_sfil )
{
	Sfil_pair *sfil_pair;
	sfil_pair = sfil_pair_create( key_sfil, response_sfil, NON );
	if( key_sfil->type == response_sfil->type )
	{
		switch( key_sfil->type )
		{
		case POINTER_FILL:
			sfil_pair->status =
				pointerfill_match(key_sfil->fill.ptr, 
						  response_sfil->fill.ptr, 
						  sfil_pair->tallies);
			break;
		case STRING_FILL:
			sfil_pair->status =
				stringfill_match(key_sfil->fill.str, 
						 response_sfil->fill.str, 
						 sfil_pair->tallies);
			break;
		case SET_FILL:
			sfil_pair->status = 
				setfill_match(key_sfil->fill.set, 
					      response_sfil->fill.set, 
					      sfil_pair->tallies);
			break;
		default: 
			break;
		}
		
		sfil_pair->score = compute_tallies_f( sfil_pair->tallies , F_PR );
	}
	return sfil_pair;
}

/*******************************************  
 *
 * alignment of "incorrect" instances/slots/mfils/sfils
 *
 *******************************************
 */

static
void
align_iin( TABLE *key_insts, TABLE *response_insts, TABLE *inst_pairs )
{
	int num_unaligned_keys, num_unaligned_responses, num_all_pairs;
	Inst_pair **all_pairs;
	
	num_unaligned_keys      = inst_count_unaligned( key_insts );
	num_unaligned_responses = inst_count_unaligned( response_insts );
	num_all_pairs = num_unaligned_keys * num_unaligned_responses;
	
	all_pairs = (Inst_pair **)calloc(num_all_pairs, sizeof(Inst_pair *));
	
	align_iin_pair_all(key_insts, response_insts, all_pairs);
	
	qsort( all_pairs, num_all_pairs, sizeof(Inst_pair *), inst_pair_wrong_compare );
	
	align_iin_choose_pairs(all_pairs, num_all_pairs, inst_pairs );
	
	free(all_pairs);
}

static
void
align_iin_pair_all(TABLE *key_insts, TABLE *response_insts, Inst_pair **all_pairs )
{
	int i=0;
	Inst *key_inst, *response_inst;
	
	table_first(key_insts);
	for(key_inst = (Inst *)table_next(key_insts);
	    key_inst;
	    key_inst = (Inst *)table_next(key_insts) )
		if( !(key_inst->is_aligned) )
		{
			table_first(response_insts);
			for(response_inst = (Inst *)table_next(response_insts);
			    response_inst;
			    response_inst = (Inst *)table_next(response_insts) )
				if( !(response_inst->is_aligned) )
					all_pairs[i++] = pair_iin( key_inst, response_inst );
		}
}

static
void
align_iin_choose_pairs(Inst_pair **all_pairs, 
		       int num_all_pairs, 
		       TABLE *inst_pairs )
{
	int i;
	Inst_pair *inst_pair;
	
	for(i=0; i<num_all_pairs; i++)
	{
		inst_pair = all_pairs[i];
		if((!(inst_pair->key_inst->is_aligned))
		   &&
		   (!(inst_pair->response_inst->is_aligned)))
		{
			table_append((char *) inst_pair, inst_pairs );
			
			inst_pair->key_inst->is_aligned = True;
			inst_pair->key_inst->its_pair = inst_pair;
			inst_pair->key_inst->aligned_with 
				= inst_pair->response_inst;
			
			inst_pair->response_inst->is_aligned = True;
			inst_pair->response_inst->its_pair = inst_pair;
			inst_pair->response_inst->aligned_with 
				= inst_pair->key_inst;
		}
		else
			inst_pair_release( (char *)inst_pair );
	}
}

static
Inst_pair *
pair_iin( Inst *key_inst, Inst *response_inst )
{
	Inst_pair *inst_pair;
	inst_pair = inst_pair_create( key_inst, response_inst, INC );
	align__sl_iin( key_inst->slots, response_inst->slots, inst_pair->slot_pairs );
	slot_pair_sum_tallies( inst_pair->tallies, inst_pair->slot_pairs );
	inst_pair->score = compute_tallies_f( inst_pair->tallies , F_PR );
	return inst_pair;
}

static
void
align__sl_iin( TABLE *key_slots, TABLE *response_slots, TABLE *slot_pairs )
{
	slot_clear_aligned_flags( key_slots );
	slot_clear_aligned_flags( response_slots );
	
	align_rsl( key_slots, slot_pairs );
	
	align_usl( key_slots, response_slots, slot_pairs );
	
	align_osl( key_slots, slot_pairs );
	
	align_isl( key_slots, response_slots, slot_pairs );
	
	align_msl( key_slots, slot_pairs );
	align_ssl( response_slots, slot_pairs );  
}

static
void
align_isl( TABLE *key_slots, TABLE *response_slots, TABLE *slot_pairs )
{
	Slot *key_slot, *response_slot;
	Slot_pair *slot_pair;
	
	table_first( key_slots );
	for(key_slot=(Slot *)table_next(key_slots);
	    key_slot;
	    key_slot=(Slot *)table_next(key_slots))
		if( !(key_slot->is_aligned) )
		{
			response_slot=slot_find(response_slots, key_slot->name);
			if( response_slot )
			{
				slot_pair = pair_isl( key_slot, response_slot );
				key_slot->is_aligned = True;
				response_slot->is_aligned = True;
				table_append((char *) slot_pair, slot_pairs );
			}
		}
}

static
Slot_pair *
pair_isl( Slot *key_slot, Slot *response_slot )
{
	Slot_pair *slot_pair;
	
	slot_pair = slot_pair_create( key_slot, response_slot, INC );
	align__mf_isl( key_slot->mfils, response_slot->mfils, slot_pair->mfil_pairs );
	mfil_pair_sum_tallies( slot_pair->tallies, slot_pair->mfil_pairs );
	slot_pair->score = compute_tallies_f(slot_pair->tallies, F_PR );
	return slot_pair;
}

static
void
align__mf_isl(TABLE *key_mfils, TABLE *response_mfils, TABLE *mfil_pairs )
{
	mfil_clear_aligned_flags( key_mfils );
	mfil_clear_aligned_flags( response_mfils );  
	
	align_rmf(key_mfils, mfil_pairs);
	
	align_imf( key_mfils, response_mfils, mfil_pairs );
	
	/* this is K2R so any leftover mfils are unscored */
	align_umf( key_mfils, response_mfils, mfil_pairs );
}

static
void
align_imf( TABLE *key_mfils, TABLE *response_mfils, TABLE *mfil_pairs )
{
	int num_unaligned_keys, num_unaligned_responses, num_all_pairs;
	Mfil_pair **all_pairs;
	
	num_unaligned_keys      = mfil_count_unaligned( key_mfils );
	num_unaligned_responses = mfil_count_unaligned( response_mfils );
	num_all_pairs = num_unaligned_keys * num_unaligned_responses;
	
	all_pairs = (Mfil_pair **)calloc(num_all_pairs, sizeof(Mfil_pair *));
	
	align_imf_pair_all(key_mfils,
			   response_mfils,
			   all_pairs);
	
	qsort(all_pairs,
	      num_all_pairs,
	      sizeof(Mfil_pair *),
	      mfil_pair_wrong_compare );
	
	align_imf_choose_pairs(all_pairs,
			       num_all_pairs,
			       mfil_pairs );
	
	free(all_pairs);
}

static
void
align_imf_pair_all(TABLE *key_mfils, TABLE *response_mfils, Mfil_pair **all_pairs )
{
	int i=0;
	Mfil *key_mfil, *response_mfil;
	
	table_first(key_mfils);
	for(key_mfil = (Mfil *)table_next(key_mfils);
	    key_mfil;
	    key_mfil = (Mfil *)table_next(key_mfils) )
		if( !(key_mfil->is_aligned) )
		{
			table_first(response_mfils);
			for(response_mfil = (Mfil *)table_next(response_mfils);
			    response_mfil;
			    response_mfil = (Mfil *)table_next(response_mfils) )
				if( !(response_mfil->is_aligned) )
					all_pairs[i++] = pair_imf( key_mfil, response_mfil );
		}
}

static
void
align_imf_choose_pairs(Mfil_pair **all_pairs, 
		       int num_all_pairs, 
		       TABLE *mfil_pairs )
{
	int i;
	Mfil_pair *mfil_pair;
	
	for(i=0; i<num_all_pairs; i++)
	{
		mfil_pair = all_pairs[i];
		if((!(mfil_pair->key_mfil->is_aligned))
		    &&
		   (!(mfil_pair->response_mfil->is_aligned)))
		{
			table_append((char *) mfil_pair, mfil_pairs );
			mfil_pair->key_mfil->is_aligned = True;
			mfil_pair->response_mfil->is_aligned = True;
		}
		else
			mfil_pair_release( (char *)mfil_pair );
	}
}

static
Mfil_pair *
pair_imf( Mfil *key_mfil, Mfil *response_mfil )
{
	Mfil_pair *mfil_pair;
	mfil_pair = mfil_pair_create( key_mfil, response_mfil, INC );
	align__sf_imf( key_mfil->sfils, response_mfil->sfils, mfil_pair->sfil_pairs );
	sfil_pair_sum_tallies( mfil_pair->tallies, mfil_pair->sfil_pairs );
	mfil_pair->score = compute_tallies_f( mfil_pair->tallies , F_PR );
	return mfil_pair;
}


static
void
align__sf_imf(TABLE *key_sfils, TABLE *response_sfils, TABLE *sfil_pairs )
{
	sfil_clear_aligned_flags( key_sfils );
	sfil_clear_aligned_flags( response_sfils );  
	
	align_rsf(key_sfils, sfil_pairs);
	
	align_isf( key_sfils, response_sfils, sfil_pairs );
	
	align_msf( key_sfils, sfil_pairs );
	align_ssf( response_sfils, sfil_pairs );
}

static
void
align_isf( TABLE *key_sfils, TABLE *response_sfils, TABLE *sfil_pairs )
{
	Sfil *key_sfil, *response_sfil;
	Sfil_pair *sfil_pair;
	
	table_first(key_sfils);
	
	for(key_sfil=(Sfil *)table_next(key_sfils);
	    key_sfil;
	    key_sfil=(Sfil *)table_next(key_sfils))
		if( !(key_sfil->is_aligned) )
		{
			table_first(response_sfils);
			for(response_sfil=(Sfil *)table_next(response_sfils);
			    response_sfil;
			    response_sfil=(Sfil *)table_next(response_sfils))
				if( !(response_sfil->is_aligned) )
				{
					sfil_pair = pair_isf( key_sfil, response_sfil );
					key_sfil->is_aligned = True;
					response_sfil->is_aligned = True;
					table_append((char *) sfil_pair, sfil_pairs );
					break;
				}
			
		}
}

static
Sfil_pair *
pair_isf( Sfil *key_sfil, Sfil *response_sfil )
{
	Sfil_pair *sfil_pair;
	sfil_pair = sfil_pair_create( key_sfil, response_sfil, INC );
	tally1_incorrect( sfil_pair->tallies );
	sfil_pair->score = compute_tallies_f( sfil_pair->tallies , F_PR );
	
	return sfil_pair;
}

/*****************************************
 *
 *  alignment of unscored slot/mfil/sfil
 *
 ******************************************
 */

static
void
align_usl(TABLE *key_slots, TABLE *response_slots, TABLE *slot_pairs)
{
	Slot *key_slot;
	Slot *response_slot;
	Slot_pair *slot_pair;

	/* start with keys, and find matching responses */
	table_first( key_slots );
	for(key_slot=(Slot *)table_next(key_slots);
	    key_slot;
	    key_slot=(Slot *)table_next(key_slots) )
		if((!(key_slot->is_aligned))
		   && 
		   slot_is_unscored(key_slot))
		{
			response_slot = slot_find(response_slots,
						  key_slot->name);
			slot_pair = pair_usl( key_slot, response_slot );
			key_slot->is_aligned = True;
			if(response_slot)
				response_slot->is_aligned = True;
			table_append((char *) slot_pair, slot_pairs );
		}

	/* now find unmatched responses */
	table_first( response_slots );
	for(response_slot=(Slot *)table_next(response_slots);
	    response_slot;
	    response_slot=(Slot *)table_next(response_slots) )
		if((!(response_slot->is_aligned))
		   && 
		   slot_is_unscored(response_slot) )
		{
			slot_pair = pair_usl( NULL, response_slot );
			response_slot->is_aligned = True;
			table_append((char *) slot_pair, slot_pairs );
		}
}
	
static
Slot_pair *
pair_usl( Slot *key_slot, Slot *response_slot )
{
	Slot_pair *slot_pair;
	
	slot_pair = slot_pair_create( key_slot, response_slot, UNSCORED );
	if(key_slot && !response_slot)
		align__mf_usl(key_slot->mfils, 
			      NULL, 
			      slot_pair->mfil_pairs );
	else if(!key_slot && response_slot)
		align__mf_usl(NULL, 
			      response_slot->mfils, 
			      slot_pair->mfil_pairs );
	else if(key_slot && response_slot)
		align__mf_usl(key_slot->mfils,
			      response_slot->mfils, 
			      slot_pair->mfil_pairs );
	mfil_pair_sum_tallies(slot_pair->tallies,
			      slot_pair->mfil_pairs);
	slot_pair->score = 
		compute_tallies_f(slot_pair->tallies,
				  F_PR);

	return slot_pair;
}

static
void
align__mf_usl( TABLE *key_mfils, TABLE *response_mfils, TABLE *mfil_pairs )
{
	if(key_mfils)
		mfil_clear_aligned_flags( key_mfils );
	if(response_mfils)
		mfil_clear_aligned_flags( response_mfils );
	
	align_umf( key_mfils, response_mfils, mfil_pairs );
}

static
void
align_umf( TABLE *key_mfils, TABLE *response_mfils, TABLE *mfil_pairs )
{
	Mfil *key_mfil;
	Mfil *response_mfil;
	Mfil_pair *mfil_pair;

	if(key_mfils && !response_mfils)
	{
		table_first(key_mfils);
		for(key_mfil=(Mfil *)table_next(key_mfils);
		    key_mfil;
		    key_mfil=(Mfil *)table_next(key_mfils))
			if( !(key_mfil->is_aligned) )
			{
				mfil_pair = pair_umf(key_mfil, NULL);
				key_mfil->is_aligned = True;
				table_append((char *) mfil_pair, mfil_pairs );
			}
	}
	else if(response_mfils && !key_mfils)
	{
		table_first(response_mfils);
		for(response_mfil=(Mfil *)table_next(response_mfils);
		    response_mfil;
		    response_mfil=(Mfil *)table_next(response_mfils))
			if( !(response_mfil->is_aligned) )
			{
				mfil_pair = pair_umf(NULL, response_mfil);
				response_mfil->is_aligned = True;
				table_append((char *) mfil_pair, mfil_pairs );
			}
	}
	else if(key_mfils && response_mfils)
	{
		table_first(key_mfils);
		table_first(response_mfils);
		
		key_mfil=(Mfil *)table_next(key_mfils);
		response_mfil=(Mfil *)table_next(response_mfils);

		while(key_mfil && response_mfil)
		{
			if(key_mfil->is_aligned)
				key_mfil=(Mfil *)table_next(key_mfils);
			else if(response_mfil->is_aligned)
				response_mfil=(Mfil *)table_next(response_mfils);
			else
			{
				mfil_pair = pair_umf(key_mfil, response_mfil);
				key_mfil->is_aligned = True;
				response_mfil->is_aligned = True;
				table_append((char *) mfil_pair, mfil_pairs );
				key_mfil=(Mfil *)table_next(key_mfils);
				response_mfil=(Mfil *)table_next(response_mfils);
			}
		}
		if( key_mfil )
			do
			{
				if( !(key_mfil->is_aligned) )
				{
					mfil_pair = pair_umf(key_mfil, NULL);
					key_mfil->is_aligned = True;
					table_append((char *)mfil_pair, 
						     mfil_pairs );
				}
				key_mfil=(Mfil *)table_next(key_mfils);
			}
			while(key_mfil);
		else if( response_mfil )
			do
			{
				if( !(response_mfil->is_aligned) )
				{
					mfil_pair=pair_umf(NULL, response_mfil);
					response_mfil->is_aligned = True;
					table_append((char *)mfil_pair, 
						     mfil_pairs );
				}
				response_mfil=(Mfil *)table_next(response_mfils);
			}
			while( response_mfil );
	}
}


static
Mfil_pair *
pair_umf( Mfil *key_mfil, Mfil *response_mfil )
{
	Mfil_pair *mfil_pair;
	
	mfil_pair = mfil_pair_create( key_mfil, response_mfil, UNSCORED );
	if(key_mfil && !response_mfil )
		align__sf_umf(key_mfil->sfils, 
			      NULL, 
			      mfil_pair->sfil_pairs );
	else if(response_mfil && !key_mfil )
		align__sf_umf(NULL, 
			      response_mfil->sfils, 
			      mfil_pair->sfil_pairs );
	else if(key_mfil && response_mfil)
		align__sf_umf(key_mfil->sfils, 
			      response_mfil->sfils, 
			      mfil_pair->sfil_pairs );
	sfil_pair_sum_tallies(mfil_pair->tallies,
			      mfil_pair->sfil_pairs);
	mfil_pair->score = 
		compute_tallies_f(mfil_pair->tallies,
				  F_PR);
	
	return mfil_pair;
}

static
void
align__sf_umf( TABLE *key_sfils, TABLE *response_sfils, TABLE *sfil_pairs )
{
	if( key_sfils )
		sfil_clear_aligned_flags( key_sfils );
	if( response_sfils )
		sfil_clear_aligned_flags( response_sfils );
	align_usf( key_sfils, response_sfils, sfil_pairs );
}

static
void
align_usf( TABLE *key_sfils, TABLE *response_sfils, TABLE *sfil_pairs )
{
	Sfil *key_sfil;
	Sfil *response_sfil;
	Sfil_pair *sfil_pair;

	if(key_sfils && !response_sfils)
	{
		table_first(key_sfils);
		for(key_sfil=(Sfil *)table_next(key_sfils);
		    key_sfil;
		    key_sfil=(Sfil *)table_next(key_sfils))
		{
			sfil_pair = pair_usf(key_sfil, NULL);
			key_sfil->is_aligned = True;
			table_append((char *) sfil_pair, sfil_pairs );
		}
	}
	else if(response_sfils && !key_sfils)
	{
		table_first(response_sfils);
		for(response_sfil=(Sfil *)table_next(response_sfils);
		    response_sfil;
		    response_sfil=(Sfil *)table_next(response_sfils))
		{
			sfil_pair = pair_usf(NULL, response_sfil);
			response_sfil->is_aligned = True;
			table_append((char *) sfil_pair, sfil_pairs );
		}
	}
	else if(key_sfils && response_sfils)
	{
		table_first(key_sfils);
		table_first(response_sfils);
		
		for(key_sfil=(Sfil *)table_next(key_sfils),
		    response_sfil=(Sfil *)table_next(response_sfils);
		    
		    (key_sfil && response_sfil);
		    
		    key_sfil=(Sfil *)table_next(key_sfils),
		    response_sfil=(Sfil *)table_next(response_sfils))
		{
			sfil_pair = pair_usf(key_sfil, response_sfil);
			key_sfil->is_aligned = True;
			response_sfil->is_aligned = True;
			table_append((char *) sfil_pair, sfil_pairs );
		}
		if( key_sfil )
			do
			{
				sfil_pair = pair_usf(key_sfil, NULL);
				key_sfil->is_aligned = True;
				table_append((char *) sfil_pair, sfil_pairs );
				key_sfil=(Sfil *)table_next(key_sfils);
			}
			while(key_sfil);
		else if( response_sfil )
			do
			{
				sfil_pair = pair_usf(NULL, response_sfil);
				response_sfil->is_aligned = True;
				table_append((char *) sfil_pair, sfil_pairs );
				response_sfil=(Sfil *)table_next(response_sfils);
			}while( response_sfil );
	}
}

static
Sfil_pair *
pair_usf( Sfil *key_sfil, Sfil *response_sfil )
{
	Sfil_pair *sfil_pair;
	
	sfil_pair = sfil_pair_create( key_sfil, response_sfil, UNSCORED );
	tally1_noncommittal(sfil_pair->tallies);
	
	return sfil_pair;
}


/**************************************
 *
 * alignment of removed slot/mfil/sfil
 *
 **************************************
 */

static
void
align_rsl( TABLE *key_slots, TABLE *slot_pairs )
{
	Slot *key_slot;
	Slot_pair *slot_pair;
	
	table_first( key_slots );
	for(key_slot=(Slot *)table_next(key_slots);
	    key_slot;
	    key_slot=(Slot *)table_next(key_slots) )
		if( !key_slot->is_aligned && slot_is_removed(key_slot) )
		{
			slot_pair = pair_rsl( key_slot );
			key_slot->is_aligned = True;
			table_append((char *) slot_pair, slot_pairs );
		}
}

static
Slot_pair *
pair_rsl( Slot *key_slot )
{
	Slot_pair *slot_pair;
	
	slot_pair = slot_pair_create( key_slot, NULL, REMOVED );

	align__mf_rsl( key_slot->mfils, slot_pair->mfil_pairs );
	mfil_pair_sum_tallies(slot_pair->tallies,
			      slot_pair->mfil_pairs);
	slot_pair->score = 
		compute_tallies_f(slot_pair->tallies,
				  F_PR);

	return slot_pair;
}

static
void
align__mf_rsl( TABLE *mfils, TABLE *mfil_pairs )
{
	mfil_clear_aligned_flags( mfils );
	align_rmf( mfils, mfil_pairs );
}

static
void
align_rmf( TABLE *key_mfils, TABLE *mfil_pairs )
{
	Mfil *key_mfil;
	Mfil_pair *mfil_pair;
	
	table_first(key_mfils);
	for(key_mfil=(Mfil *)table_next(key_mfils);
	    key_mfil;
	    key_mfil=(Mfil *)table_next(key_mfils) )
		if( !key_mfil->is_aligned && mfil_is_removed(key_mfil) )
		{
			mfil_pair = pair_rmf( key_mfil );
			key_mfil->is_aligned = True;
			table_append((char *) mfil_pair, mfil_pairs );
		}
}

static
Mfil_pair *
pair_rmf( Mfil *key_mfil )
{
	Mfil_pair *mfil_pair;
	
	mfil_pair = mfil_pair_create( key_mfil, NULL, REMOVED );

	align__sf_rmf( key_mfil->sfils, mfil_pair->sfil_pairs );
	sfil_pair_sum_tallies(mfil_pair->tallies, 
			      mfil_pair->sfil_pairs );
	mfil_pair->score = 
		compute_tallies_f(mfil_pair->tallies,
				  F_PR);

	return mfil_pair;
}

static
void
align__sf_rmf( TABLE *sfils, TABLE *sfil_pairs )
{
	sfil_clear_aligned_flags( sfils );
	align_rsf( sfils, sfil_pairs );
}

static
void
align_rsf( TABLE *key_sfils, TABLE *sfil_pairs )
{
	Sfil *key_sfil;
	Sfil_pair *sfil_pair;
	
	table_first(key_sfils);
	for(key_sfil=(Sfil *)table_next(key_sfils);
	    key_sfil;
	    key_sfil=(Sfil *)table_next(key_sfils) )
		if( !key_sfil->is_aligned && sfil_is_removed(key_sfil) )
		{
			sfil_pair = pair_rsf( key_sfil );
			key_sfil->is_aligned = True;
			table_append((char *) sfil_pair, sfil_pairs );
		}
}


static
Sfil_pair *
pair_rsf( Sfil *key_sfil )
{
	Sfil_pair *sfil_pair;
	
	sfil_pair = sfil_pair_create( key_sfil, NULL, REMOVED );
	tally1_noncommittal(sfil_pair->tallies);
	
	return sfil_pair;
}

/**************************************
 *
 * alignment of missing inst/slot/mfil/sfil
 *
 **************************************
 */

void
align_min( TABLE *key_insts, TABLE *inst_pairs )
{
	Inst *key_inst;
	Inst_pair *inst_pair;
	
	table_first(key_insts);
	for(key_inst     =(Inst *)table_next(key_insts);
	    key_inst;
	    key_inst     =(Inst *)table_next(key_insts))
		if( !key_inst->is_aligned )
		{
			inst_pair = pair_min( key_inst );
			key_inst->is_aligned = True;
			key_inst->its_pair = inst_pair;
			table_append((char *) inst_pair, inst_pairs );
		}
}

Inst_pair *
pair_min( Inst *key_inst )
{
	Inst_pair *inst_pair;
	
	inst_pair = inst_pair_create( key_inst, NULL, MIS );
	align__sl_min( key_inst->slots, inst_pair->slot_pairs );
	slot_pair_sum_tallies( inst_pair->tallies, inst_pair->slot_pairs );
	inst_pair->score = compute_tallies_f( inst_pair->tallies , F_PR );
	return inst_pair;
}

static
void
align__sl_min( TABLE *key_slots, TABLE *slot_pairs )
{
	slot_clear_aligned_flags( key_slots );
	if( IS_K2R )
		align_rsl( key_slots, slot_pairs );
	align_usl( key_slots, NULL, slot_pairs );
	align_osl( key_slots, slot_pairs );
	align_msl( key_slots, slot_pairs );
}


static
void
align_msl( TABLE *key_slots, TABLE *slot_pairs )
{
	Slot *key_slot;
	Slot_pair *slot_pair;
	
	table_first( key_slots );
	for(key_slot=(Slot *)table_next(key_slots);
	    key_slot;
	    key_slot=(Slot *)table_next(key_slots) )
		if( !key_slot->is_aligned )
		{
			slot_pair = pair_msl( key_slot );
			key_slot->is_aligned = True;
			table_append((char *) slot_pair, slot_pairs );
		}
}

static
Slot_pair *
pair_msl( Slot *key_slot )
{
	Slot_pair *slot_pair;
	
	slot_pair = slot_pair_create( key_slot, NULL, MIS );
	align__mf_msl( key_slot->mfils, slot_pair->mfil_pairs );
	mfil_pair_sum_tallies( slot_pair->tallies, slot_pair->mfil_pairs );
	slot_pair->score = compute_tallies_f( slot_pair->tallies , F_PR );
	return slot_pair;
}

static
void
align__mf_msl( TABLE *key_mfils, TABLE *mfil_pairs )
{
	mfil_clear_aligned_flags( key_mfils );
	if( IS_K2R )
	{
		align_rmf( key_mfils, mfil_pairs );
		align_mmf_k2r( key_mfils, mfil_pairs );
		align_umf( key_mfils, NULL, mfil_pairs );
	}
	else
		align_mmf_k2k( key_mfils, mfil_pairs );
}

static
void
align_mmf_k2r( TABLE *key_mfils, TABLE *mfil_pairs )
{
	Mfil *key_mfil;
	Mfil *smallest_mfil;
	long smallest_mfil_size = MAX_MESSSIZE;
	long this_mfil_size;
	Mfil_pair *mfil_pair;

	table_first(key_mfils);
	for(key_mfil=(Mfil *)table_next(key_mfils);
	    key_mfil;
	    key_mfil=(Mfil *)table_next(key_mfils) )
		if(!(key_mfil->is_aligned))
		{
			this_mfil_size = table_count(key_mfil->sfils);
			if( this_mfil_size < smallest_mfil_size )
			{
				smallest_mfil = key_mfil;
				smallest_mfil_size = this_mfil_size;
			}
		}
	mfil_pair = pair_mmf( smallest_mfil );
	smallest_mfil->is_aligned = True;
	table_append((char *) mfil_pair, mfil_pairs );
}

static
void
align_mmf_k2k( TABLE *key_mfils, TABLE *mfil_pairs )
{
	Mfil *key_mfil;
	Mfil_pair *mfil_pair;

	table_first(key_mfils);
	for(key_mfil=(Mfil *)table_next(key_mfils);
	    key_mfil;
	    key_mfil=(Mfil *)table_next(key_mfils) )
		if( !key_mfil->is_aligned )
		{
			mfil_pair = pair_mmf( key_mfil );
			key_mfil->is_aligned = True;
			table_append((char *) mfil_pair, mfil_pairs );
		}
}

static
Mfil_pair *
pair_mmf( Mfil *key_mfil )
{
	Mfil_pair *mfil_pair;
	
	mfil_pair = mfil_pair_create( key_mfil, NULL, MIS );
	align__sf_mmf( key_mfil->sfils, mfil_pair->sfil_pairs );
	sfil_pair_sum_tallies( mfil_pair->tallies, mfil_pair->sfil_pairs );
	mfil_pair->score = compute_tallies_f( mfil_pair->tallies , F_PR );
	return mfil_pair;
}

static
void
align__sf_mmf( TABLE *key_sfils, TABLE *sfil_pairs )
{
	sfil_clear_aligned_flags( key_sfils );
	if( IS_K2R )
		align_rsf( key_sfils, sfil_pairs );
	align_msf( key_sfils, sfil_pairs );
}

static
void
align_msf( TABLE *key_sfils, TABLE *sfil_pairs )
{
	Sfil *key_sfil;
	Sfil_pair *sfil_pair;
	
	table_first(key_sfils);
	for(key_sfil=(Sfil *)table_next(key_sfils);
	    key_sfil;
	    key_sfil=(Sfil *)table_next(key_sfils) )
		if( !key_sfil->is_aligned )
		{
			sfil_pair = pair_msf( key_sfil );
			key_sfil->is_aligned = True;
			table_append((char *) sfil_pair, sfil_pairs );
		}
}


static
Sfil_pair *
pair_msf( Sfil *sfil )
{
	Sfil_pair *sfil_pair;
	
	sfil_pair = sfil_pair_create( sfil, NULL, MIS );
	tally1_missing( sfil_pair->tallies );
	sfil_pair->score = compute_tallies_f( sfil_pair->tallies , F_PR );
	
	return sfil_pair;
}

/**************************************
 *
 * alignment of spurious inst/slot/mfil/sfil
 *
 **************************************
 */

void
align_sin( TABLE *insts, TABLE *inst_pairs )
{
	Inst *inst;
	Inst_pair *inst_pair;
	
	table_first(insts);
	for(inst     =(Inst *)table_next(insts);
	    inst;
	    inst     =(Inst *)table_next(insts))
		if( !inst->is_aligned )
		{
			inst_pair = pair_sin( inst );
			inst->is_aligned = True;
			inst->its_pair = inst_pair;
			table_append((char *) inst_pair, inst_pairs );
		}
}

Inst_pair *
pair_sin( Inst *inst )
{
	Inst_pair *inst_pair;
	
	inst_pair = inst_pair_create( NULL, inst, SPU );
	align__sl_sin( inst->slots, inst_pair->slot_pairs );
	slot_pair_sum_tallies( inst_pair->tallies, inst_pair->slot_pairs );
	inst_pair->score = compute_tallies_f( inst_pair->tallies , F_PR );
	return inst_pair;
}

static
void
align__sl_sin( TABLE *slots, TABLE *slot_pairs )
{
	slot_clear_aligned_flags( slots );
	align_usl( NULL, slots, slot_pairs );
	align_ssl( slots, slot_pairs );
}


static
void
align_ssl( TABLE *slots, TABLE *slot_pairs )
{
	Slot *slot;
	Slot_pair *slot_pair;
	
	table_first( slots );
	for(slot=(Slot *)table_next(slots);
	    slot;
	    slot=(Slot *)table_next(slots) )
		if( !slot->is_aligned )
		{
			slot_pair = pair_ssl( slot );
			slot->is_aligned = True;
			table_append((char *) slot_pair, slot_pairs );
		}
}

static
Slot_pair *
pair_ssl( Slot *slot )
{
	Slot_pair *slot_pair;
	
	slot_pair = slot_pair_create( NULL, slot, SPU );
	align__mf_ssl( slot->mfils, slot_pair->mfil_pairs );
	mfil_pair_sum_tallies( slot_pair->tallies, slot_pair->mfil_pairs );
	slot_pair->score = compute_tallies_f( slot_pair->tallies , F_PR );
	return slot_pair;
}

static
void
align__mf_ssl( TABLE *mfils, TABLE *mfil_pairs )
{
	mfil_clear_aligned_flags( mfils );
	align_smf( mfils, mfil_pairs );
}

static
void
align_smf( TABLE *mfils, TABLE *mfil_pairs )
{
	Mfil *mfil;
	Mfil_pair *mfil_pair;
	
	table_first(mfils);
	for(mfil=(Mfil *)table_next(mfils);
	    mfil;
	    mfil=(Mfil *)table_next(mfils) )
		if( !mfil->is_aligned )
		{
			mfil_pair = pair_smf( mfil );
			mfil->is_aligned = True;
			table_append((char *) mfil_pair, mfil_pairs );
		}
}

static
Mfil_pair *
pair_smf( Mfil *mfil )
{
	Mfil_pair *mfil_pair;
	
	mfil_pair = mfil_pair_create( NULL, mfil, SPU );
	align__sf_smf( mfil->sfils, mfil_pair->sfil_pairs );
	sfil_pair_sum_tallies( mfil_pair->tallies, mfil_pair->sfil_pairs );
	mfil_pair->score = compute_tallies_f( mfil_pair->tallies , F_PR );
	return mfil_pair;
}

static
void
align__sf_smf( TABLE *sfils, TABLE *sfil_pairs )
{
	sfil_clear_aligned_flags( sfils );
	align_ssf( sfils, sfil_pairs );
}

static
void
align_ssf( TABLE *sfils, TABLE *sfil_pairs )
{
	Sfil *sfil;
	Sfil_pair *sfil_pair;
	
	table_first(sfils);
	for(sfil=(Sfil *)table_next(sfils);
	    sfil;
	    sfil=(Sfil *)table_next(sfils) )
		if( !sfil->is_aligned )
		{
			sfil_pair = pair_ssf( sfil );
			sfil->is_aligned = True;
			table_append((char *) sfil_pair, sfil_pairs );
		}
}


static
Sfil_pair *
pair_ssf( Sfil *sfil )
{
	Sfil_pair *sfil_pair;
	
	sfil_pair = sfil_pair_create( NULL, sfil, SPU );
	tally1_spurious( sfil_pair->tallies );
	sfil_pair->score = compute_tallies_f( sfil_pair->tallies , F_PR );
	
	return sfil_pair;
}

/**************************************
 *
 * alignment of optional inst/slot/mfil/sfil
 *
 **************************************
 */

void
align_oin( TABLE *insts, TABLE *inst_pairs )
{
	Inst *inst;
	Inst_pair *inst_pair;
	
	table_first(insts);
	for(inst = (Inst *)table_next(insts);
	    inst;
	    inst = (Inst *)table_next(insts))
		if( !inst->is_aligned && inst->is_optional )
		{
			inst_pair = pair_oin( inst );
			inst->is_aligned = True;
			inst->its_pair = inst_pair;
			table_append((char *) inst_pair, inst_pairs );
		}
}

Inst_pair *
pair_oin( Inst *inst )
{
	Inst_pair *inst_pair;
	
	inst_pair = inst_pair_create( inst, NULL, OPT );
	align__sl_oin( inst->slots, inst_pair->slot_pairs );
	slot_pair_sum_tallies( inst_pair->tallies, inst_pair->slot_pairs );
	inst_pair->score = compute_tallies_f( inst_pair->tallies , F_PR );
	return inst_pair;
}

static
void
align__sl_oin( TABLE *slots, TABLE *slot_pairs )
{
	slot_clear_aligned_flags( slots );
	align_usl( slots, NULL, slot_pairs );
	align_osl_oin( slots, slot_pairs );
}

/* slots which are optional because the instance is optional */

static
void
align_osl_oin( TABLE *slots, TABLE *slot_pairs )
{
	Slot *slot;
	Slot_pair *slot_pair;
	
	table_first( slots );
	for(slot=(Slot *)table_next(slots);
	    slot;
	    slot=(Slot *)table_next(slots) )
		if( !slot->is_aligned )
		{
			slot_pair = pair_osl( slot );
			slot->is_aligned = True;
			table_append((char *) slot_pair, slot_pairs );
		}
}

/* slots which are optional because they are marked optional */

static
void
align_osl( TABLE *slots, TABLE *slot_pairs )
{
	Slot *slot;
	Slot_pair *slot_pair;
	
	table_first( slots );
	for(slot=(Slot *)table_next(slots);
	    slot;
	    slot=(Slot *)table_next(slots) )
		if( !slot->is_aligned && slot->is_optional )
		{
			slot_pair = pair_osl( slot );
			slot->is_aligned = True;
			table_append((char *) slot_pair, slot_pairs );
		}
}


static
Slot_pair *
pair_osl( Slot *slot )
{
	Slot_pair *slot_pair;
	
	slot_pair = slot_pair_create( slot, NULL, OPT );
	align__mf_osl( slot->mfils, slot_pair->mfil_pairs );
	mfil_pair_sum_tallies( slot_pair->tallies, slot_pair->mfil_pairs );
	slot_pair->score = compute_tallies_f( slot_pair->tallies , F_PR );
	return slot_pair;
}

static
void
align__mf_osl( TABLE *mfils, TABLE *mfil_pairs )
{
	mfil_clear_aligned_flags( mfils );
	align_omf( mfils, mfil_pairs );
}

static
void
align_omf( TABLE *mfils, TABLE *mfil_pairs )
{
	Mfil *mfil;
	Mfil_pair *mfil_pair;
	
	table_first(mfils);
	for(mfil=(Mfil *)table_next(mfils);
	    mfil;
	    mfil=(Mfil *)table_next(mfils) )
		if( !mfil->is_aligned )
		{
			mfil_pair = pair_omf( mfil );
			mfil->is_aligned = True;
			table_append((char *) mfil_pair, mfil_pairs );
		}
}

static
Mfil_pair *
pair_omf( Mfil *mfil )
{
	Mfil_pair *mfil_pair;
	
	mfil_pair = mfil_pair_create( mfil, NULL, OPT );
	align__sf_omf( mfil->sfils, mfil_pair->sfil_pairs );
	sfil_pair_sum_tallies( mfil_pair->tallies, mfil_pair->sfil_pairs );
	mfil_pair->score = compute_tallies_f( mfil_pair->tallies , F_PR );
	return mfil_pair;
}

static
void
align__sf_omf( TABLE *sfils, TABLE *sfil_pairs )
{
	sfil_clear_aligned_flags( sfils );
	align_osf( sfils, sfil_pairs );
}

static
void
align_osf( TABLE *sfils, TABLE *sfil_pairs )
{
	Sfil *sfil;
	Sfil_pair *sfil_pair;
	
	table_first(sfils);
	for(sfil=(Sfil *)table_next(sfils);
	    sfil;
	    sfil=(Sfil *)table_next(sfils) )
		if( !sfil->is_aligned )
		{
			sfil_pair = pair_osf( sfil );
			sfil->is_aligned = True;
			table_append((char *) sfil_pair, sfil_pairs );
		}
}


static
Sfil_pair *
pair_osf( Sfil *sfil )
{
	Sfil_pair *sfil_pair;
	
	sfil_pair = sfil_pair_create( sfil, NULL, OPT );
	tally1_noncommittal( sfil_pair->tallies );
	sfil_pair->score = compute_tallies_f( sfil_pair->tallies , F_PR );
	
	return sfil_pair;
}

