%{
/*
 *  Copyright 1995 Science Applications International Corporation.
 */

/*
 * NAME
 *
 * 
 * FILE 
 *	@(#)config.l	6.1
 *
 * SYNOPSIS
 *
 *
 * DESCRIPTION
 *      lexer for MUC scorer configuration files
 *
 * DIAGNOSTICS
 *
 *
 * FILES
 *
 *
 * NOTES
 *	Scratch pad - modification history, plans for enhancements.
 * 
 * SEE ALSO
 *
 * AUTHOR
 *	Gary Dungca	August 1995
 *
 */

#ifdef SCCSID
static char SccsId[] = "@(#)config.l	6.1\t09/08/97\tSAIC";
#endif

#undef SCCSID
#include  "muc_defs.h"
#include  "muc.h"
#include  "muc_protos.h"
#include  "muc_globals.h"

#include "y.config.h"

#undef yywrap

/*********************************************************************
 *                                                                   *
 *  lex definitions to parse MUC configuration file.                 *
 *                                                                   *
 ********************************************************************/

extern void yyerror(const char *msg);

int  configlineno;

%}

%%

%{
/* comments */
%}

^#.*				{ ; }

%{
/* option name */
%}

^:([a-zA-Z][a-zA-Z0-9_\-]*)	{ yylval.sval = (char *) strdup(yytext);
				  return OPTION; }

%{
/* single-quoted string */
%}

(\'[^\'\n]*\')			{ yylval.sval = (char *) strdup(yytext);
				  return QSTRING; }

%{
/* double-quoted string */
%}

(\"[^\"\n]*\")			{ yylval.sval = (char *) strdup(yytext);
				  return QSTRING; }

%{
/* text */
%}

[^ \t\n]+			{ yylval.sval = (char *) strdup(yytext);
				  return VALUE; }

%{
/* eol */
%}

\n				{ configlineno++; }

%{
/* whitespace */
%}

[ \t]				{ ; }

%{
/* other */
%}

.				{ yyerror("invalid character"); }

%%

void
yyerror(const char *msg)
{
    printf("(config) %d: %s at '%s'\n", configlineno, msg, yytext);
}

int
yywrap(void)
{
    return(1);
}

