/*
 *  Copyright 1997 Science Applications International Corporation.
 */

/*
 * FILE 
 *	eqclasset.c
 *
 * SYNOPSIS
 *
 * DESCRIPTION
 *	support routines for Eqclasset data structure.
 *
 * DIAGNOSTICS
 *
 * FILES
 *
 * NOTES
 * 
 * SEE ALSO
 *
 * AUTHOR
 *
 */

#ifdef SCCSID
static char SccsId[] = "@(#)eqclasset.c	6.1\t09/08/97\tSAIC";
#endif

#undef SCCSID
#include  "muc_defs.h"
#include  "muc.h"
#include  "muc_protos.h"
#include  "muc_globals.h"

/************************************************************************
 *									*
 *  eqclasset_create
 *									*
 ***********************************************************************/

Eqclasset *
eqclasset_create()
{
    Eqclasset *eqclasset;
    
    if((eqclasset = UALLOC(Eqclasset, 1)) == (Eqclasset *)NULL)
    {
	fprintf(stderr, "Error: [eqclasset_create]: Allocation failed.\n");
	exit(1);
    }
    
    eqclasset->eqclasses = table_list_create(default_compar,
					     eqclass_release,
					     default_destroy);
    eqclasset->eqmaps = table_hash_create(eqmap_compare,
					  eqmap_release,
					  default_destroy,
					  eqmap_hash,
					  4);
    return eqclasset;
}


/************************************************************************
 *									*
 *  eqclasset_release 
 *									*
 ***********************************************************************/

void
eqclasset_release(char *elt)
{
	Eqclasset *eqclasset;
	if( elt == NULL ) return;

	eqclasset = (Eqclasset *) elt;
	table_destroy(eqclasset->eqclasses);
	table_destroy(eqclasset->eqmaps);
	UFREE(eqclasset);
}

void
eqclasset_print_table(TABLE *eqclassets, int indent)
{
	Eqclasset *eqclasset;
	
	if(eqclassets == NULL) return;
	
	printf("%*.sEqclassets:\n", indent, "");
	table_first(eqclassets);
	for(eqclasset=(Eqclasset *)table_next(eqclassets);
	    eqclasset;
	    eqclasset=(Eqclasset *)table_next(eqclassets))
		eqclasset_print(eqclasset, indent+2);
}		

void
eqclasset_print(Eqclasset *eqclasset, int indent)
{
	if(eqclasset == NULL) return;
       
	printf("%*.sEqclasset:\n", indent, "");
	eqclass_print_table(eqclasset->eqclasses, indent+2);
	/*
	eqmap_print_table(eqclasset->eqmaps, indent+2);
	*/
}
