/*
 *  Copyright 1995 Science Applications International Corporation.
 */

/*
 * FILE 
 *	@(#)massage.c	6.1\t09/08/97
 *
 * SYNOPSIS
 *
 *
 * DESCRIPTION
 *      stuff to do after parsing but before aligning keys and responses
 *
 * DIAGNOSTICS
 *
 *
 * FILES
 *
 *
 * NOTES
 * 
 * SEE ALSO
 *
 * AUTHOR
 */

#ifdef SCCSID
static char SccsId[] = "@(#)massage.c	6.1\t09/08/97\tSAIC";
#endif

#undef SCCSID
#include  "muc_defs.h"
#include  "muc.h"
#include  "muc_protos.h"
#include  "muc_globals.h"


static void check_status_slots_in_classes(TABLE *classes);
static void check_status_slots_in_insts( TABLE *insts );


void
check_status_slots_in_entry(Catalog_entry *entry)
{
	check_status_slots_in_classes(entry->key_classes);
	check_status_slots_in_classes(entry->response_classes);
}

static
void
check_status_slots_in_classes(TABLE *classes)
{
	Clas *clas;
	
	table_first(classes);
	for(clas = (Clas *)table_next(classes);	
	    clas;
	    clas = (Clas *)table_next(classes))
		check_status_slots_in_insts( clas->insts );
}

static
void
check_status_slots_in_insts( TABLE *insts )
{
	Inst *inst;
	char *slotname;
	Slot *slot;
	char *fill;
	TABLE *values;
	char *value;
	
	slotname = option_find_first_value(MUC_Options,
					   ":optional_status_slot");
	
	table_first(insts);
	for(inst=(Inst *)table_next(insts);
	    inst;
	    inst=(Inst *)table_next(insts))
	{
		slot = slot_find(inst->slots, slotname);
		if( slot )
			inst->is_optional = True;
	}
}

	
