/*
 *  Copyright 1995 Science Applications International Corporation.
 */

/*
 * FILE 
 *	@(#)massage_NE.c	6.1\t09/08/97
 *
 * SYNOPSIS
 *
 *
 * DESCRIPTION
 *      stuff to do after parsing but before aligning keys and responses
 *
 * DIAGNOSTICS
 *
 *
 * FILES
 *
 *
 * NOTES
 * 
 * SEE ALSO
 *
 * AUTHOR
 */

#ifdef SCCSID
static char SccsId[] = "@(#)massage_NE.c	6.1\t09/08/97\tSAIC";
#endif

#undef SCCSID
#include  "muc_defs.h"
#include  "muc.h"
#include  "muc_protos.h"
#include  "muc_globals.h"

static void move_ALT_to_TEXT_in_entry(Catalog_entry *entry);
static void move_ALT_to_TEXT_in_classes(TABLE *classes);
static void move_ALT_to_TEXT_in_insts(TABLE *insts);
static void move_ALT_to_TEXT_in_slots(Slot *text_slot, Slot *alt_slot);
static void move_ALT_to_TEXT_in_mfils(TABLE *text_mfils, TABLE *alt_mfils);

void
massage_NE_entry(Catalog_entry *entry)
{
	change_cr_to_spc_in_entry( entry );
	trim_TEXT_whitespace_in_entry( entry );
	calc_substring_offsets_in_entry( entry );
	move_ALT_to_TEXT_in_entry(entry);
	check_status_slots_in_entry(entry);
	make_clean_stringfills_entry(entry);
}

static
void
move_ALT_to_TEXT_in_entry(Catalog_entry *entry)
{
	move_ALT_to_TEXT_in_classes(entry->key_classes);
	move_ALT_to_TEXT_in_classes(entry->response_classes);
}

static
void
move_ALT_to_TEXT_in_classes(TABLE *classes)
{
	Clas *clas;
	
	table_first(classes);
	for(clas=(Clas *)table_next(classes);
	    clas;
	    clas=(Clas *)table_next(classes))
		move_ALT_to_TEXT_in_insts(clas->insts);
}

static
void
move_ALT_to_TEXT_in_insts(TABLE *insts)
{
	Inst *inst;
	Slot *alt_slot;
	Slot *text_slot;
	char *alt_slotname;
	char *text_slotname;

	alt_slotname=option_find_first_value(MUC_Options,
					     ":sgml_ALT_slot");
	text_slotname=option_find_first_value(MUC_Options,
					      ":sgml_TEXT_slot");

	table_first(insts);
	for(inst=(Inst *)table_next(insts);
	    inst;
	    inst=(Inst *)table_next(insts))
	{
		alt_slot = slot_find(inst->slots,
				     alt_slotname);
		text_slot = slot_find(inst->slots,
				      text_slotname);
		if(alt_slot && text_slot)
		{
			move_ALT_to_TEXT_in_slots(text_slot, 
						  alt_slot);
			/* Pointer to data is reset, */
			/* so we can delete alt_slot */
			table_delete((char *)alt_slot, 
				     inst->slots);
		}
	}
}

static
void
move_ALT_to_TEXT_in_slots(Slot *text_slot, Slot *alt_slot)
{
	move_ALT_to_TEXT_in_mfils(text_slot->mfils,
				  alt_slot->mfils);
}

static
void
move_ALT_to_TEXT_in_mfils(TABLE *text_mfils, TABLE *alt_mfils)
{
	Mfil *mfil;
	Mfil *new_mfil;

	table_first(alt_mfils);
	for(mfil=(Mfil *)table_next(alt_mfils);
	    mfil;
	    mfil=(Mfil *)table_next(alt_mfils))
	{
		new_mfil = mfil_create();
		new_mfil->is_aligned = mfil->is_aligned;
		new_mfil->sfils = mfil->sfils;
		/* allows deletion of alt_slot */
		mfil->sfils = NULL;
		table_append((char *)new_mfil, text_mfils);
	}
}	
