/*
 *  Copyright 1997 Science Applications International Corporation.
 */

/*
 *  SccsId:  @(#)muc_defs.h	6.1\t09/08/97
 */


#ifndef _MUC_DEFS_H_
#define _MUC_DEFS_H_	1

#ifdef SCCSID
static char DefsSccsId[] = "@(#)muc_defs.h	6.1\t09/08/97\tSAIC";
#endif


#include <stdio.h>
#include <malloc.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <ctype.h>

#undef SCCSID
#include "table.h"

#ifdef Bool
#undef Bool
#endif
typedef char	Bool;

#ifndef NULL
#define NULL	0
#endif

#ifndef False
#define False		0
#define True		1
#endif

/* values for global variable MUC_task */

#define	SCENARIO_TEMPLATE 1
#define	TEMPLATE_ELEMENT  2
#define	TEMPLATE_RELATION 3
#define NAMED_ENTITY      4
#define COREFERENCE       5

#define IS_ST (MUC_task==SCENARIO_TEMPLATE)
#define IS_TE (MUC_task==TEMPLATE_ELEMENT)
#define IS_TR (MUC_task==TEMPLATE_RELATION)
#define IS_NE (MUC_task==NAMED_ENTITY)
#define IS_CO (MUC_task==COREFERENCE)
#define IS_IE (IS_ST||IS_TE||IS_TR)

#define KEY2RESPONSE 1
#define KEY2KEY      2

#define IS_K2R (MUC_method==KEY2RESPONSE)
#define IS_K2K (MUC_method==KEY2KEY)

/* values for global variable MUC_key_or_response */

#define	KEY	  1
#define	RESPONSE  2
#define TEXT      3

/* alignment result */

#define  COR       1
#define  INC       2
#define  PAR       3
#define  MIS       4
#define  SPU       5
#define  OPT       6
#define  NON       7
#define  REMOVED   8
#define  UNSCORED  9

/* which part of stringfills do we compare? */

#define ORIG         1
#define STRAIGHTENED 2
#define CLEAN        3
#define NONE         4

/* f-measure types */

#define  F_PR   1
#define  F_2PR  2
#define  F_P2R  3

/* basic fill types */

#define	 STRING_FILL	   1
#define  POINTER_FILL	   2
#define  SET_FILL	   3
#define  UNKNOWN           4

/* convenient sizes for getting input */	

#define BUFLENGTH	256
#define MAX_MESSSIZE	1024

#define STRCASEEQ(a,b)		(muc_strcasecmp((a), (b)) == 0)


#endif /*_MUC_DEFS_H_ */
