/*
 * NAME
 * 
 * FILE 
 *     @(#)output_IE.c	6.1
 *
 * SYNOPSIS
 *
 * DESCRIPTION
 *
 * DIAGNOSTICS
 *
 * FILES
 *
 * SEE ALSO
 *
 * AUTHOR
 * 
 */

#ifdef SCCSID
static char SccsId[] = "@(#)output_IE.c	6.1\t09/08/97\tSAIC";
#endif

#undef SCCSID
#include  "muc_defs.h"
#include  "muc.h"
#include  "muc_protos.h"
#include  "muc_globals.h"

static void display_entry_text_filtering(Catalog_entry *entry);
static void display_entry_text_filtering(Catalog_entry *entry);
static void display_summary_text_filtering();
static void display_entry_subtask_scores(Catalog_entry *entry);
static void display_summary_subtask_scores();
static void display_entry_doc_section_scores(Catalog_entry *entry);
static void display_summary_doc_section_scores();
static void display_entry_class_scores(Catalog_entry *entry);
static void display_summary_class_scores();
static void display_entry_slot_scores(Catalog_entry *entry);
static void display_summary_slot_scores();
static void display_entry_total_slot_scores(Catalog_entry *entry);
static void display_summary_total_slot_scores();
static void display_entry_f_measures(Catalog_entry *entry);
static void display_summary_f_measures();
static void display_subtask_scores(TABLE *subtask_tallies_table);
static Named_tallies **named_tallies_make_sorted_array(TABLE *named_tallieses);
static int named_tallies_name_compare(const void *v1, const void *v2);
static void split_subtask_string(char *subtask_string,
				 char **class_name,
				 char **slot_name,
				 char **fill);
static void display_doc_section_scores(TABLE *doc_section_tallieses,
				       TABLE *dsg_tallieses);
static void display_class_scores(TABLE *class_scores);
static void display_slot_scores_in_class_scores(TABLE *class_scores);
static void display_slot_scores(Class_def *class_def, TABLE *slot_scores);
static void format_tallies(char *id, Tallies *tallies);
static void format_f_measures(Tallies *tallies);

void
display_entry_scores_IE(Catalog_entry *entry)
{
	fprintf(MUC_score_report_file,
		"\f\nDocument: %s\n",
		entry->docnum);
	fprintf(MUC_score_report_file,
		"%s%s%s",
		"------------------------------------------------------------------------------\n",
		"               POS   ACT| COR PAR INC | MIS  SPU  NON| REC PRE UND OVG SUB ERR\n",
		"------------------------+-------------+--------------+------------------------\n");
	
        if( IS_ST )
		display_entry_text_filtering(entry);
	if( IS_NE )
	{
		display_entry_subtask_scores(entry);
		display_entry_doc_section_scores(entry);
	}
	display_entry_class_scores(entry);
	display_entry_slot_scores(entry);
	display_entry_total_slot_scores(entry);
	display_entry_f_measures(entry);
}

void
display_summary_scores_IE()
{
	fprintf(MUC_score_report_file,
		"\f\n * * * SUMMARY SCORES * * *\n");
	fprintf(MUC_score_report_file,
		"%s%s%s",
		"------------------------------------------------------------------------------\n",
		"               POS   ACT| COR PAR INC | MIS  SPU  NON| REC PRE UND OVG SUB ERR\n",
		"------------------------+-------------+--------------+------------------------\n");
	if( IS_ST )
		display_summary_text_filtering();
	if( IS_NE )
	{
		display_summary_subtask_scores();
		display_summary_doc_section_scores();
	}
	display_summary_class_scores();
	display_summary_slot_scores();
	display_summary_total_slot_scores();
	display_summary_f_measures();
}

static
void
display_entry_text_filtering(Catalog_entry *entry)
{
	format_tallies("TEXT FILTERING", entry->text_filtering );
}

static
void
display_summary_text_filtering()
{
	format_tallies("TEXT FILTERING", MUC_Total_Text_Filtering );
}

static
void
display_entry_subtask_scores(Catalog_entry *entry)
{
	display_subtask_scores(entry->ne_subtask_tallies);
}

static
void
display_summary_subtask_scores()
{
	display_subtask_scores(MUC_ne_subtask_tallies);
}

static
void
display_entry_doc_section_scores(Catalog_entry *entry)
{
	display_doc_section_scores(entry->ne_doc_section_tallies,
				   entry->dsg_tallies);
}

static
void
display_summary_doc_section_scores()
{
	display_doc_section_scores(MUC_ne_doc_section_tallies,
				   MUC_dsg_tallies);
}

static
void
display_entry_class_scores(Catalog_entry *entry)
{
	display_class_scores(entry->class_scores);
}

static
void
display_summary_class_scores()
{
	display_class_scores(MUC_Summary_Class_scores);
}

static
void
display_entry_slot_scores(Catalog_entry *entry)
{
	display_slot_scores_in_class_scores(entry->class_scores);
}

static
void
display_summary_slot_scores()
{
	display_slot_scores_in_class_scores(MUC_Summary_Class_scores);
}

static
void
display_entry_total_slot_scores(Catalog_entry *entry)
{
	fprintf(MUC_score_report_file,
		"------------------------+-------------+--------------+------------------------\n");
	format_tallies("ALL SLOTS", entry->total_slot_tallies );
}

static
void
display_summary_total_slot_scores()
{
	fprintf(MUC_score_report_file,
		"------------------------+-------------+--------------+------------------------\n");
	format_tallies("ALL SLOTS", MUC_Total_Slot_tallies );
}

static
void
display_entry_f_measures(Catalog_entry *entry)
{
	format_f_measures(entry->total_slot_tallies);
}

static
void
display_summary_f_measures()
{
	format_f_measures(MUC_Total_Slot_tallies);
}

/***********************************************************************

 subtask scores (for named entity)

 ***********************************************************************/

static
void
display_subtask_scores(TABLE *subtask_tallies_table)
{
	Named_tallies *named_tallies;
	int i = 0;
	char *cur_class_name;
	char *class_name=NULL; 
	char *slot_name=NULL;
	char *fill=NULL;
	char indented_fill[50];

	fprintf(MUC_score_report_file,
		"SUBTASK SCORES          |             |              |                        \n");

	table_first(subtask_tallies_table);
	for(named_tallies = (Named_tallies *)table_next(subtask_tallies_table);
	    named_tallies;
	    named_tallies = (Named_tallies *)table_next(subtask_tallies_table))
	{
		split_subtask_string(named_tallies->name,
				     &class_name,
				     &slot_name,
				     &fill);
		if( i==0 )
		{
			cur_class_name = STRALLOC(class_name);
			fprintf(MUC_score_report_file,
				"%-13.12s%12s%14s%15s\n",
				cur_class_name,
				"|", "|", "|");
			i = 1;
		}
		else if( !STRCASEEQ(cur_class_name, class_name) )
		{
			UFREE(cur_class_name);
			cur_class_name = STRALLOC(class_name);
			fprintf(MUC_score_report_file,
				"%-13.12s%12s%14s%15s\n",
				cur_class_name,
				"|", "|", "|");
		}

		sprintf(indented_fill, " %s", fill);
		format_tallies(indented_fill, named_tallies->tallies);

		UFREE(class_name);
		UFREE(slot_name);
		UFREE(fill);
	}
	
	UFREE(cur_class_name);
}

static
void
split_subtask_string(char *subtask_string,
		     char **class_name,
		     char **slot_name,
		     char **fill)
{
	char *p1, *p2;
	
	p1 = subtask_string + strspn(subtask_string, " \t"); /* skip ws */
	p2 = p1 + strcspn(p1, " \t");                        /* find ws */
	(*class_name) = alloc_between(p1, p2);
	
	p1 = p2 + strspn(p2, " \t");                         /* skip ws */
	p2 = p1 + strcspn(p1, " \t");                        /* find ws */
	(*slot_name) = alloc_between(p1, p2);

	p1 = p2 + strspn(p2, " \t");                         /* skip ws */
	p2 = p1 + strcspn(p1, " \t");                        /* find ws */
	(*fill) = alloc_between(p1, p2);
}

/***********************************************************************

 doc section scores (for named entity)

 ***********************************************************************/

static
void
display_doc_section_scores(TABLE *doc_section_tallieses,
			   TABLE *dsg_tallieses)
{
	Named_tallies *dst;        /* "doc section tallies"       */
	Named_tallies *dsgt;       /* "doc section group tallies" */
	char *p1, *p2, *dsg_name;
	
	fprintf(MUC_score_report_file,
		"------------------------+-------------+--------------+------------------------\n");
	fprintf(MUC_score_report_file,
		"%-13.12s%12s%14s%15s\n",
		"SECT SCORES",
		"|","|","|");
	if((dsg_tallieses == NULL)
	   || 
	   (table_count(dsg_tallieses) == 0))
	{
		table_first(doc_section_tallieses);
		for(dst=(Named_tallies *)table_next(doc_section_tallieses);
		    dst;
		    dst=(Named_tallies *)table_next(doc_section_tallieses))
			format_tallies(dst->name, dst->tallies);
		
	}
	else
	{
		table_first(dsg_tallieses);
		for(dsgt=(Named_tallies *)table_next(dsg_tallieses);
		    dsgt;
		    dsgt=(Named_tallies *)table_next(dsg_tallieses))
		{
			p1 = dsgt->name + strspn(dsgt->name, " \t");
			p2 = p1 + strcspn(p1, " \t");
			dsg_name = alloc_between(p1, p2);

			format_tallies(dsg_name, dsgt->tallies);

			UFREE(dsg_name);
		}
	}
}
/************************************************************************
 *									*
 * display class scores
 *									*
 ***********************************************************************/

static
void
display_class_scores(TABLE *class_scores)
{
	Class_score *class_score;
	Class_def *class_def;

	fprintf(MUC_score_report_file,
		"%s%-13.12s%12s%14s%15s\n",
		"------------------------+-------------+--------------+------------------------\n",
		"OBJ SCORES",
		"|","|","|");

	table_first(class_scores);
	for(class_score=(Class_score *)table_next(class_scores);
	    class_score;
	    class_score=(Class_score *)table_next(class_scores))
	{
		class_def = class_def_find(MUC_Class_defs, 
					   class_score->name);
		if( class_def )
			format_tallies(class_def->score_report_name, 
				       class_score->tallies);
	}
}
			
/************************************************************************
 *									*
 * display slot scores
 *									*
 ***********************************************************************/

static
void
display_slot_scores_in_class_scores(TABLE *class_scores)
{
	Class_score *class_score;
	Class_def *class_def;
	
	fprintf(MUC_score_report_file,
		"%s%-13.12s%12s%14s%15s\n",
		"------------------------+-------------+--------------+------------------------\n",
		"SLOT SCORES",
		"|","|","|");

	table_first(class_scores);
	for(class_score=(Class_score *)table_next(class_scores);
	    class_score;
	    class_score=(Class_score *)table_next(class_scores))
	{
		class_def = class_def_find(MUC_Class_defs, 
					   class_score->name);
		if( class_def )
		{
			fprintf(MUC_score_report_file,
				"%-13.12s%12s%14s%15s\n",
				class_def->score_report_name,
				"|","|","|");
			display_slot_scores(class_def,
					    class_score->slot_scores);
		}
	}
}

static
void
display_slot_scores(Class_def *class_def, TABLE *slot_scores)
{
	Slot_score *slot_score;
	Slot_def *slot_def;
	char slot_name[50];
	
	table_first(slot_scores);
	for(slot_score=(Slot_score *)table_next(slot_scores);
	    slot_score;
	    slot_score=(Slot_score *)table_next(slot_scores))
	{
		slot_def = 
			slot_def_find(class_def->slot_defs,
				      slot_score->name);
		if(slot_def)
		{
			sprintf(slot_name, " %s", slot_def->score_report_name);
			format_tallies(slot_name,
				       slot_score->tallies);
		}
	}
}

		
			
/************************************************************************
 *									*
 *  format_tallies							*
 *									*
 ***********************************************************************/

static
void
format_tallies(char *id, Tallies *tallies)
{
    int  recall, precision;
    int  undergeneration, overgeneration;
    int  error_prf, substitution;

    /* the following computed measures are cast to int to truncate the
       decimal value.  however, in order to round 'up' if the decimal
       is > .5, we add 0.5 before truncating. */

    recall = (int) (0.5 + compute_recall(tallies));
    precision = (int) (0.5 + compute_precision(tallies));
    undergeneration = (int) (0.5 + compute_undergeneration(tallies));
    overgeneration = (int) (0.5 + compute_overgeneration(tallies));
    substitution = (int) (0.5 + compute_substitution(tallies));
    error_prf = (int) (0.5 + compute_error_per_response_fill(tallies));
    
    fprintf(MUC_score_report_file,
	    "%-13.12s%5d %5d|%4d %3d %4d|%4d %4d %4d|",
	    id,
	    tallies->possible,
	    tallies->actual,
	    tallies->correct,
	    tallies->partial,
	    tallies->incorrect,
	    tallies->missing,
	    tallies->spurious,
	    tallies->noncommittal);

    if (recall == -1.0)
	fprintf(MUC_score_report_file, "   *");
    else
	fprintf(MUC_score_report_file, "%4d", recall);
    
    if (precision == -1.0)
	fprintf(MUC_score_report_file, "   *");
    else
	fprintf(MUC_score_report_file, "%4d", precision);
    
    if (undergeneration == -1.0)
	fprintf(MUC_score_report_file, "   *");
    else
	fprintf(MUC_score_report_file, "%4d", undergeneration);
    
    if (overgeneration == -1.0)
	fprintf(MUC_score_report_file, "   *");
    else
	fprintf(MUC_score_report_file, "%4d", overgeneration);
    
    if (substitution == -1.0)
	fprintf(MUC_score_report_file, "   *");
    else
	fprintf(MUC_score_report_file, "%4d", substitution);
    
    if (error_prf == -1.0)
	fprintf(MUC_score_report_file, "   *");
    else
	fprintf(MUC_score_report_file, "%4d", error_prf);

    fprintf(MUC_score_report_file, "\n");
    
    return;
}


/************************************************************************
 *									*
 *  format_f_measures							*
 *									*
 ***********************************************************************/

static
void
format_f_measures(Tallies *tallies)
{
    float fpr, f2pr, fp2r;
    
    fpr = compute_tallies_f(tallies, F_PR);
    f2pr = compute_tallies_f(tallies, F_2PR);
    fp2r = compute_tallies_f(tallies, F_P2R);
    
    fprintf(MUC_score_report_file, "%55s%10s%10s\n", "P&R", "2P&R", "P&2R");
    
    if( (fpr < 0.0) || (f2pr < 0.0) || (fp2r < 0.0))
	fprintf(MUC_score_report_file,
		"F-MEASURES not available - Recall or Precision invalid.\n");
    else
	fprintf(MUC_score_report_file,
		"F-MEASURES%45.2f%10.2f%10.2f\n", fpr, f2pr, fp2r);

    return;
}


