/*
 * NAME
 * 
 * FILE 
 *     @(#)output_coref.c	6.1\t09/08/97
 *
 * SYNOPSIS
 *
 * DESCRIPTION
 *
 * DIAGNOSTICS
 *
 * FILES
 *
 * SEE ALSO
 *
 * AUTHOR
 * 
 */

#ifdef SCCSID
static char SccsId[] = "@(#)output_coref.c	6.1\t09/08/97\tSAIC";
#endif

#undef SCCSID
#include  "muc_defs.h"
#include  "muc.h"
#include  "muc_protos.h"
#include  "muc_globals.h"


/* coref map history beta */
/*
static void display_inst_pairs(TABLE *inst_pairs);
*/
static char *get_TEXT_fill(Inst *inst);
static Stringfill *get_TEXT_stringfill(Inst *inst);
static char *get_ID_fill(Inst *inst);

static float compute_entry_f(Catalog_entry *entry);
static float compute_summary_f();

static void display_partitioned_key_class(Partitionset *partitionset, 
					  int key_class_num);
static void display_matched_key_partitions(Partitionset *partitionset, 
					   int key_class_num);
static void display_key_partition(TABLE *inst_pairs);
static void display_missing_partitions(Partitionset *partitionset, 
				       int key_class_num);
static void display_partitioned_response_class(Partitionset *partitionset, 
					       int resp_class_num);
static void display_matched_response_partitions(Partitionset *partitionset, 
						int resp_class_num);
static void display_response_partition(TABLE *inst_pairs);
static void display_spurious_partitions(Partitionset *partitionset, 
					int resp_class_num);
static void display_matched_CO_key_inst(Inst_pair *inst_pair);
static void display_matched_CO_response_inst(Inst_pair *inst_pair);
static void display_missing_CO_inst(Inst_pair *inst_pair);
static void display_spurious_CO_inst(Inst_pair *inst_pair);


/* coref map history from beta version */

#if 0

void
display_entry_map_history_CO(Catalog_entry *entry)
{
	Clas_pair *clas_pair;
	TABLE *inst_pairs;
	
	if(entry == NULL) return;
	if( entry->clas_pairs == NULL )
	{
		fprintf(stderr,
			"display_entry_map_history: entry has no class_pairs!\n");
		exit(1);
	}
	
	table_first(entry->clas_pairs);
	clas_pair = (Clas_pair *)table_next(entry->clas_pairs);
	if( clas_pair == NULL )
	{
		fprintf(stderr,
			"display_entry_map_history: entry has no class pairs!\n");
		exit(1);
	}
	
	inst_pairs = clas_pair->inst_pairs;
	fprintf(MUC_map_history_file,
		"Document %s\n",
		entry->docnum);
	display_inst_pairs(inst_pairs);
}


static
void
display_inst_pairs(TABLE *inst_pairs)
{
	Inst_pair *inst_pair;
	Inst *key_inst;
	Inst *resp_inst;
	
	char *key_text;
	char *resp_text;
	char *key_id;
	char *resp_id;
	
	table_first(inst_pairs);
	for(inst_pair=(Inst_pair *)table_next(inst_pairs);
	    inst_pair;
	    inst_pair=(Inst_pair *)table_next(inst_pairs))
	{
		key_inst = inst_pair->key_inst;
		resp_inst = inst_pair->response_inst;
		if( key_inst )
		{
			key_text = get_TEXT_fill(key_inst);
			key_id = get_ID_fill(key_inst);
		}
		if( resp_inst )
		{
			resp_text = get_TEXT_fill(resp_inst);
			resp_id = get_ID_fill(resp_inst);
		}
		if( key_inst && resp_inst )
			fprintf(MUC_map_history_file,	
				"C \"%s\" \"%s\" %s %s\n",
				key_text,
				resp_text,
				key_id,
				resp_id);
		else if( key_inst )
			fprintf(MUC_map_history_file,	
				"M \"%s\" %s\n",
				key_text,
				key_id);
		else if( resp_inst )
			fprintf(MUC_map_history_file,
				"S \"%s\" %s\n",
				resp_text,
				resp_id);
	}
}

#endif

static
char *
get_ID_fill(Inst *inst)
{
	return get_inst_ID_slot_fill(inst); /* in massage_CO.c */
}

static
Stringfill *
get_TEXT_stringfill(Inst *inst)
{
	Slot *slot;
	char *slotname;
	Mfil *mfil;
	Sfil *sfil;
	
	slotname = option_find_first_value(MUC_Options, ":sgml_TEXT_slot");
	if(slotname == NULL) return NULL;
	if(inst == NULL) return NULL;
	if( inst->slots == NULL ) return NULL;
	slot = slot_find(inst->slots, slotname);
	if(slot == NULL) return NULL;
	if(slot->mfils == NULL) return NULL;
	table_first(slot->mfils);
	mfil = (Mfil *)table_next(slot->mfils);
	if( mfil == NULL ) return NULL;
	table_first(mfil->sfils);
	sfil = (Sfil *)table_next(mfil->sfils);
	if( sfil == NULL ) return NULL;
	
	if( sfil->type != STRING_FILL ) return NULL;
	return sfil->fill.str;
}

static
char *
get_TEXT_fill(Inst *inst)
{
	Stringfill *stringfill;
	
	stringfill = get_TEXT_stringfill(inst);
	if(stringfill)
		return stringfill->fill;
	else
		return NULL;
}


void
display_scores_header_CO()
{
	fprintf(MUC_score_report_file,
		"%21s %5s\n",
		"Key",
		"Rsp");
	
	fprintf(MUC_score_report_file,
		"%-15s %5s %5s %19s %23s %7s\n\n",
		"Document No.",
		"Cls",
		"Cls",
		"Recall   ",
		"Precision",
		"f");
}	

void
display_entry_scores_CO(Catalog_entry *entry)
{
	fprintf(MUC_score_report_file,
		"%-15s %5d %5d %7d / %-5d %5.1f     %5d / %-5d %5.1f %6.1f\n",
		entry->docnum,
		entry->partitionset->num_key_classes,
		entry->partitionset->num_resp_classes,
		entry->recall_numerator,
		entry->recall_denominator,
		(entry->recall_denominator ? 
		 (100.0 * 
		  ((float)(entry->recall_numerator) / 
		   (float)(entry->recall_denominator))) :
		 0.0),
		entry->precision_numerator,
		entry->precision_denominator,
		(entry->precision_denominator ? 
		 (100.0 * 
		  ((float)(entry->precision_numerator) / 
		   (float)(entry->precision_denominator))) :
		 0.0),
		100.0 * compute_entry_f(entry)
		);
}

static
float
compute_entry_f(Catalog_entry *entry)
{
	if(entry==NULL)
		return;
	if(entry->recall_denominator
	   &&
	   entry->precision_denominator)
		return compute_f(0.5,
				 ((float)(entry->precision_numerator)/
				  (float)(entry->precision_denominator)),
				 ((float)(entry->recall_numerator)/
				  (float)(entry->recall_denominator)));
	else
		return 0.0;
}

				 

void
display_summary_scores_CO()
{
	fprintf(MUC_score_report_file,
		"\n%-15s %5d %5d %7d / %-5d %5.1f%%    %5d / %-5d %5.1f%% %5.1f%%\n",
		"TOTALS:",
		MUC_total_key_eqclasses,
		MUC_total_response_eqclasses,
		MUC_recall_numerator,
		MUC_recall_denominator,
		(MUC_recall_denominator ? 
		 (100.0 * ((float)MUC_recall_numerator / (float)MUC_recall_denominator)) :
		 0.0),
		MUC_precision_numerator,
		MUC_precision_denominator,
		(MUC_precision_denominator ? 
		 (100.0 * ((float)MUC_precision_numerator / (float)MUC_precision_denominator)) :
		 0.0),
		100.0 * compute_summary_f()
		);

}

static
float
compute_summary_f()
{
	if(MUC_recall_denominator
	   &&
	   MUC_precision_denominator)
		return compute_f(0.5,
				 ((float)(MUC_precision_numerator)/
				  (float)(MUC_precision_denominator)),
				 ((float)(MUC_recall_numerator)/
				  (float)(MUC_recall_denominator)));
	else
		return 0.0;
}

void
display_entry_CO_partitions(Catalog_entry *entry)
{
	Partitionset *partitionset;
	int key_class_num;
	int resp_class_num;

	partitionset = entry->partitionset;
	if(partitionset == NULL)
		return;
	
	fprintf(MUC_partition_file,
	       "Document: %s\n",
	       entry->docnum);
	
	fprintf(MUC_partition_file,
		"Key equivalence classes:\n");
	
	for(key_class_num = 0; 
	    key_class_num < (partitionset->num_key_classes);
	    key_class_num++)
		display_partitioned_key_class(partitionset, 
					      key_class_num);
	fprintf(MUC_partition_file,
	       "****************************************************\n\n");

	fprintf(MUC_partition_file,
		"Response equivalence classes:\n");
	
	for(resp_class_num = 0; 
	    resp_class_num < (partitionset->num_resp_classes); 
	    resp_class_num++)
		display_partitioned_response_class(partitionset, 
						   resp_class_num);
	fprintf(MUC_partition_file,
	       "====================================================\n\n");
}

static
void
display_partitioned_key_class(Partitionset *partitionset, 
			      int key_class_num)
{
	fprintf(MUC_partition_file,
	       "****************************************************\n\n");
	display_matched_key_partitions(partitionset, key_class_num);
	display_missing_partitions(partitionset, key_class_num);
}

static
void
display_matched_key_partitions(Partitionset *partitionset, int key_class_num)
{
	int start_index;
	int end_index;
	int i;
       
	start_index = key_class_num * (partitionset->num_resp_classes);
	end_index = start_index + (partitionset->num_resp_classes);
	
	for(i=start_index; i<end_index; i++)
		display_key_partition(partitionset->matched[i]);
}

static
void
display_key_partition(TABLE *inst_pairs)
{
	Inst_pair *inst_pair;
	
	if(table_count(inst_pairs) == 0)
		return;
	
	table_first(inst_pairs);
	for(inst_pair=(Inst_pair *)table_next(inst_pairs);
	    inst_pair;
	    inst_pair=(Inst_pair *)table_next(inst_pairs))
		display_matched_CO_key_inst(inst_pair);
	fprintf(MUC_partition_file, "\n");
}
	

static
void
display_missing_partitions(Partitionset *partitionset, int key_class_num)
{
	TABLE *inst_pairs;
	Inst_pair *inst_pair;
	
	inst_pairs = partitionset->missing[key_class_num];

	table_first(inst_pairs);
	for(inst_pair=(Inst_pair *)table_next(inst_pairs);
	    inst_pair;
	    inst_pair=(Inst_pair *)table_next(inst_pairs))
	{
		display_missing_CO_inst(inst_pair);
		fprintf(MUC_partition_file, "\n");
	}
}

static
void
display_partitioned_response_class(Partitionset *partitionset, 
				   int resp_class_num)
{
	fprintf(MUC_partition_file,
	       "====================================================\n\n");
	display_matched_response_partitions(partitionset, resp_class_num);
	display_spurious_partitions(partitionset, resp_class_num);
}

static
void
display_matched_response_partitions(Partitionset *partitionset, 
				    int resp_class_num)
{
	long initial_pos;
	long matrix_size;
	long iterator;
	long i;

	iterator = partitionset->num_resp_classes;

	matrix_size = 
		partitionset->num_key_classes * 
		partitionset->num_resp_classes;

	for(i=resp_class_num; i<matrix_size; i += iterator)
		display_response_partition(partitionset->matched[i]);
}

static
void
display_response_partition(TABLE *inst_pairs)
{
	Inst_pair *inst_pair;
	
	if(table_count(inst_pairs) == 0)
		return;
	
	table_first(inst_pairs);
	for(inst_pair=(Inst_pair *)table_next(inst_pairs);
	    inst_pair;
	    inst_pair=(Inst_pair *)table_next(inst_pairs))
		display_matched_CO_response_inst(inst_pair);
	fprintf(MUC_partition_file, "\n");
}
	
static
void
display_spurious_partitions(Partitionset *partitionset, int resp_class_num)
{
	TABLE *inst_pairs;
	Inst_pair *inst_pair;
	
	inst_pairs = partitionset->spurious[resp_class_num];

	table_first(inst_pairs);
	for(inst_pair=(Inst_pair *)table_next(inst_pairs);
	    inst_pair;
	    inst_pair=(Inst_pair *)table_next(inst_pairs))
	{
		display_spurious_CO_inst(inst_pair);
		fprintf(MUC_partition_file, "\n");
	}
}

static 
void 
display_matched_CO_key_inst(Inst_pair *inst_pair)
{
	char *key_idfill         = NULL;
	char *response_idfill    = NULL;

	Stringfill *stringfill   = NULL;
	char *textfill           = NULL;
	long start_offset        = 0;
	long end_offset          = 0;

	Pointerfill *pointerfill = NULL;
	char *p1, *p2;
	char *reffill            = NULL;
	
	key_idfill      = get_ID_fill(inst_pair->key_inst);
	response_idfill = get_ID_fill(inst_pair->response_inst);

	stringfill = get_TEXT_stringfill(inst_pair->key_inst);
	if( stringfill )
	{
		textfill = stringfill->fill;
		start_offset = stringfill->start_offset;
		end_offset = stringfill->end_offset;
	}
	
	pointerfill = get_inst_REF_slot_fill(inst_pair->key_inst);
	if( pointerfill )
	{
		p1 = pointerfill->string_rep;
		p1 = p1 + strcspn(p1, "-") + 1;
		p1 = p1 + strcspn(p1, "-") + 1;
		p2 = p1 + strcspn(p1, ">");
		
		reffill = alloc_between(p1, p2);
	}

	fprintf(MUC_partition_file,
		"C %d %d %s %s %s \"%s\"\n",
		start_offset,
		end_offset,
		(key_idfill      == NULL ? "NULL" : key_idfill),
		(reffill         == NULL ? "NULL" : reffill ),
		(response_idfill == NULL ? "NULL" : response_idfill),
		(textfill        == NULL ? "NULL" : textfill));

	UFREE(reffill);
}

static 
void 
display_matched_CO_response_inst(Inst_pair *inst_pair)
{
	char *response_idfill    = NULL;
	char *key_idfill         = NULL;

	Stringfill *stringfill   = NULL;
	char *textfill           = NULL;
	long start_offset        = 0;
	long end_offset          = 0;

	Pointerfill *pointerfill = NULL;
	char *p1, *p2;
	char *reffill            = NULL;
	
	response_idfill = get_ID_fill(inst_pair->response_inst);
	key_idfill      = get_ID_fill(inst_pair->key_inst);

	stringfill = get_TEXT_stringfill(inst_pair->response_inst);
	if( stringfill )
	{
		textfill = stringfill->fill;
		start_offset = stringfill->start_offset;
		end_offset = stringfill->end_offset;
	}
	
	pointerfill = get_inst_REF_slot_fill(inst_pair->response_inst);
	if( pointerfill )
	{
		p1 = pointerfill->string_rep;
		p1 = p1 + strcspn(p1, "-") + 1;
		p1 = p1 + strcspn(p1, "-") + 1;
		p2 = p1 + strcspn(p1, ">");
		
		reffill = alloc_between(p1, p2);
	}

	fprintf(MUC_partition_file,
		"C %d %d %s %s %s \"%s\"\n",
		start_offset,
		end_offset,
		(response_idfill == NULL ? "NULL" : response_idfill),
		(reffill         == NULL ? "NULL" : reffill ),
		(key_idfill      == NULL ? "NULL" : key_idfill),
		(textfill        == NULL ? "NULL" : textfill));

	UFREE(reffill);
}

static 
void 
display_missing_CO_inst(Inst_pair *inst_pair)
{
	char *key_idfill         = NULL;

	Stringfill *stringfill   = NULL;
	char *textfill           = NULL;
	long start_offset        = 0;
	long end_offset          = 0;

	Pointerfill *pointerfill = NULL;
	char *p1, *p2;
	char *reffill            = NULL;
	
	key_idfill      = get_ID_fill(inst_pair->key_inst);

	stringfill = get_TEXT_stringfill(inst_pair->key_inst);
	if( stringfill )
	{
		textfill = stringfill->fill;
		start_offset = stringfill->start_offset;
		end_offset = stringfill->end_offset;
	}
	
	pointerfill = get_inst_REF_slot_fill(inst_pair->key_inst);
	if( pointerfill )
	{
		p1 = pointerfill->string_rep;
		p1 = p1 + strcspn(p1, "-") + 1;
		p1 = p1 + strcspn(p1, "-") + 1;
		p2 = p1 + strcspn(p1, ">");
		
		reffill = alloc_between(p1, p2);
	}

	fprintf(MUC_partition_file,
		"M %d %d %s %s \"%s\"\n",
		start_offset,
		end_offset,
		(key_idfill      == NULL ? "NULL" : key_idfill),
		(reffill         == NULL ? "NULL" : reffill ),
		(textfill        == NULL ? "NULL" : textfill));

	UFREE(reffill);
}

static 
void 
display_spurious_CO_inst(Inst_pair *inst_pair)
{
	char *response_idfill    = NULL;

	Stringfill *stringfill   = NULL;
	char *textfill           = NULL;
	long start_offset        = 0;
	long end_offset          = 0;

	Pointerfill *pointerfill = NULL;
	char *p1, *p2;
	char *reffill            = NULL;
	
	response_idfill = get_ID_fill(inst_pair->response_inst);

	stringfill = get_TEXT_stringfill(inst_pair->response_inst);
	if( stringfill )
	{
		textfill = stringfill->fill;
		start_offset = stringfill->start_offset;
		end_offset = stringfill->end_offset;
	}
	
	pointerfill = get_inst_REF_slot_fill(inst_pair->response_inst);
	if( pointerfill )
	{
		p1 = pointerfill->string_rep;
		p1 = p1 + strcspn(p1, "-") + 1;
		p1 = p1 + strcspn(p1, "-") + 1;
		p2 = p1 + strcspn(p1, ">");
		
		reffill = alloc_between(p1, p2);
	}

	fprintf(MUC_partition_file,
		"S %d %d %s %s \"%s\"\n",
		start_offset,
		end_offset,
		(response_idfill == NULL ? "NULL" : response_idfill),
		(reffill         == NULL ? "NULL" : reffill ),
		(textfill        == NULL ? "NULL" : textfill));

	UFREE(reffill);
}
