/*
 * NAME
 * 
 * FILE 
 *     @(#)report_summary_CO.c	6.1\t09/08/97
 *
 * SYNOPSIS
 *
 * DESCRIPTION
 *
 * DIAGNOSTICS
 *
 * FILES
 *
 * SEE ALSO
 *
 * AUTHOR
 * 
 */

#ifdef SCCSID
static char SccsId[] = "@(#)report_summary_CO.c	6.1\t09/08/97\tSAIC";
#endif

#undef SCCSID
#include  "muc_defs.h"
#include  "muc.h"
#include  "muc_protos.h"
#include  "muc_globals.h"


static void display_inst_pairs(TABLE *inst_pairs);
static void display_COR_inst_pairs(TABLE *inst_pairs);
static void display_MIS_inst_pairs(TABLE *inst_pairs);
static void display_SPU_inst_pairs(TABLE *inst_pairs);
static void display_OPT_inst_pairs(TABLE *inst_pairs);
static void display_inst_pair(Inst_pair *inst_pair);
static void display_status(char status);
static Stringfill *get_TEXT_stringfill(Inst *inst);
static char *get_TEXT_fill(Inst *inst);


void
display_report_summary_CO(Catalog_entry *entry)
{
	Clas_pair *clas_pair;
	TABLE *inst_pairs;
	
	if(entry == NULL) return;
	if( entry->clas_pairs == NULL )
	{
		fprintf(stderr,
			"display_report_summary_CO: entry has no class_pairs!\n");
		exit(1);
	}
	
	table_first(entry->clas_pairs);
	clas_pair = (Clas_pair *)table_next(entry->clas_pairs);
	if( clas_pair == NULL )
	{
		fprintf(stderr,
			"display_report_summary_CO: entry has no class pairs!\n");
		exit(1);
	}
	
	inst_pairs = clas_pair->inst_pairs;
	fprintf(MUC_report_summary_file,
		"Document %s\n",
		entry->docnum);
	display_inst_pairs(inst_pairs);
}

static
void
display_inst_pairs(TABLE *inst_pairs)
{
	display_COR_inst_pairs(inst_pairs);
	display_MIS_inst_pairs(inst_pairs);
	display_SPU_inst_pairs(inst_pairs);
	display_OPT_inst_pairs(inst_pairs);
}

static
void
display_COR_inst_pairs(TABLE *inst_pairs)
{
	Inst_pair *inst_pair;

	table_first(inst_pairs);
	for(inst_pair=(Inst_pair *)table_next(inst_pairs);
	    inst_pair;
	    inst_pair=(Inst_pair *)table_next(inst_pairs))
		if( inst_pair->status == COR )
			display_inst_pair(inst_pair);
}

static
void
display_MIS_inst_pairs(TABLE *inst_pairs)
{
	Inst_pair *inst_pair;

	table_first(inst_pairs);
	for(inst_pair=(Inst_pair *)table_next(inst_pairs);
	    inst_pair;
	    inst_pair=(Inst_pair *)table_next(inst_pairs))
		if( inst_pair->status == MIS )
			display_inst_pair(inst_pair);
}

static
void
display_SPU_inst_pairs(TABLE *inst_pairs)
{
	Inst_pair *inst_pair;

	table_first(inst_pairs);
	for(inst_pair=(Inst_pair *)table_next(inst_pairs);
	    inst_pair;
	    inst_pair=(Inst_pair *)table_next(inst_pairs))
		if( inst_pair->status == SPU )
			display_inst_pair(inst_pair);
}

static
void
display_OPT_inst_pairs(TABLE *inst_pairs)
{
	Inst_pair *inst_pair;

	table_first(inst_pairs);
	for(inst_pair=(Inst_pair *)table_next(inst_pairs);
	    inst_pair;
	    inst_pair=(Inst_pair *)table_next(inst_pairs))
		if( inst_pair->status == OPT )
			display_inst_pair(inst_pair);
}

static
void
display_inst_pair(Inst_pair *inst_pair)
{
	Inst *key_inst;
	Inst *resp_inst;
	
	char *key_text=NULL;
	char *resp_text=NULL;

	display_status(inst_pair->status);

	key_inst = inst_pair->key_inst;
	resp_inst = inst_pair->response_inst;
	if( key_inst )
		key_text = get_TEXT_fill(key_inst);
	if( resp_inst )
		resp_text = get_TEXT_fill(resp_inst);
	
	if( key_text && resp_text )
		fprintf(MUC_report_summary_file,	
			" \"%s\" \"%s\"\n",
			key_text,
			resp_text);
	else if( key_text )
		fprintf(MUC_report_summary_file,	
			" \"%s\" \"\"\n",
			key_text);
	else if( resp_text )
		fprintf(MUC_report_summary_file,
			" \"\" \"%s\"\n",
			resp_text);
}

static
void
display_status(char status)
{
	switch(status)
	{
	case COR:
		fprintf(MUC_report_summary_file, "COR");
		break;
	case MIS:
		fprintf(MUC_report_summary_file, "MIS");
		break;
	case SPU:
		fprintf(MUC_report_summary_file, "SPU");
		break;
	case OPT:
		fprintf(MUC_report_summary_file, "OPT");
		break;
	default:
		fprintf(MUC_report_summary_file, "???");
		break;
	}
}

		

static
Stringfill *
get_TEXT_stringfill(Inst *inst)
{
	Slot *slot;
	char *slotname;
	Mfil *mfil;
	Sfil *sfil;
	
	slotname = option_find_first_value(MUC_Options, ":sgml_TEXT_slot");
	if(slotname == NULL) return NULL;
	if(inst == NULL) return NULL;
	if( inst->slots == NULL ) return NULL;
	slot = slot_find(inst->slots, slotname);
	if(slot == NULL) return NULL;
	if(slot->mfils == NULL) return NULL;
	table_first(slot->mfils);
	mfil = (Mfil *)table_next(slot->mfils);
	if( mfil == NULL ) return NULL;
	table_first(mfil->sfils);
	sfil = (Sfil *)table_next(mfil->sfils);
	if( sfil == NULL ) return NULL;
	
	if( sfil->type != STRING_FILL ) return NULL;
	return sfil->fill.str;
}

static
char *
get_TEXT_fill(Inst *inst)
{
	Stringfill *stringfill;
	
	stringfill = get_TEXT_stringfill(inst);
	if(stringfill)
		return stringfill->fill;
	else
		return NULL;
}

